4.7.2:  FIX: Table Data Editor: To Execute Edit on a query where the query explicitly selects columns, and the case of the column case do not match that of the databases, the column would not be editable.
        FIX: (Oracle): Script Object to XXX for procedure/functions of a package where there were no defined parameters would not script.

4.7.1:  FEATURE: Query Builder: Add Table Dialog popups up when initially opening the Query Builder
        FEATURE: Query Builder: Add Table Dialog is now modeless so that the user can add tables and work on the Diagram pane at the same time
        FEATURE: Query Analyzer Permissions: (SQL Server & Sybase): Now permissions are not applied to SQL statements on temporary tables and tables in the tempdb
        FIX: Query Builder: When a statement is executed, if a cell value in the columns pane was being worked on but not commited then it would not apply to the execution of the query.
        FIX: Query Builder: Added tables which had matching tables in other schemas would have the columns added from the other schemas into the graph as well.
        FIX: Query Builder: Creating a second JOIN criteria between two tables didn't work if the variables are (a,b) in table 1 and (b,a) in tables.  The second drag-and-drop was ignored.
        FIX: Query Builder: FULL OUTER JOIN on MySQL, Oracle 8i and Sybase was not generating complete SQL
        FIX: Query Builder: WHERE Criteria for SQL statement now has correct paranthesis for all AND and OR statements
        FIX: Script Generator: Now sorting constraints by type, then name to make diffs of schemas easier to do.
        FIX: Script Browser: F5 would not refresh.
        FIX: Script Browser: Did not have the ability to display files without an extension.  In File->Options->General:Script Filters a "*" may be added to include files without extensions
        FIX: SQL Formatter: Uppercase Keywords would not uppercase AS, CASE, THEN and ELSE
        FIX: (Sybase) Table Data Editor: If a SELECT is done on a table with no primary key or unique constraint, but has a unique index, ADS would not use it as a primary key.
        FIX: (DB2) Query Window Syntax Coloring: Added keywords COLLECT, SAMPLED and DETAILED
        FIX: (Oracle) Session Manager: Sort order in Session Stats was not saved between refreshes.

4.7.0:  CHANGE: Tagged current build as 4.7.0
        FEATURE: Visual Query Builder: Added new query builder which may be accessed through the main application toolbar and the popup menu in the schem browser

4.6.17: FEATURE: (DB2) SQL Statement Execution.  All "--" comments are removed from SQL statements except for CREATE PROCEDURE, FUNCTION and TRIGGER before execution regardless if they are client or server side comments
        FIX: Grid Results: copy to clipboard would add a line feed after last line.
        FIX: (Oracle) Script Generator: If a foreign key constraint was created on a reference table column which had an Index created on the column before the primary key constraint was created, then the reference column would not appear in the CREATE CONSTRAINT statement.

4.6.16: FEATURE: (Oracle, DB2) Query Window: There is now the ability to change the current schema.  The toolbar now has a combo box with a list of schemas. Changing the current
            schema will change the context for auto-completion and the context of the database.
        FEATURE: Syntax Coloring: Added an option in File->Options:Editor for coloring numerics. Default syntax color of numerics is magenta.
        FEATURE: Editor: Added an option in File->Options:Editor for enabling/disabling auto-brace matching. Default value is enabled.
        FEATURE: Schema Browser:
            - Added the ability to mount different folder locations into the schema browser, so that users can mount shared directories to share folders.
            - Added ability to rename a Server connection in the Server Properties
            - When deleting a folder with connections in it, ADS will notify the user that all connections and sub folders must be removed before proceeding.
            - Added the following Key Bindings to the schema browser functionalities
                - CTRL-INSERT: Connect
                - CTRL-DELETE: Disconnect
                - SHIFT-INSERT: Register Server Clone
                - ALT-ENTER: Server Properties
                - ENTER: Will expand/collapse current node
        FEATURE: (DB2) Schema Browser: Added "Materialized View" node to display a list of Materialized Views and the columns and indexes of the views
        FIX: (Oracle) Script Generator: Now includes the PUBLIC schema.
        FIX: (Sybase and SQL Server): Query Analyzer: Executing an UPDATE statement with an "exists" clause would set the Statement.setMaxRows() limiting the rows modified.
        FIX: (Sybase and SQL Server) Permissions: INSERT statements on temporary tables avoided permissions

4.6.15: FEATURE: Queray Analzyer: Optional popup confirmation dialog for uncommitted transactions now warns if a UPDATE or DELETE statement is executed without a WHERE clause
        FEATURE: Parameterized Scripts: option to define a default value for a parameter in a parameterized script
            Example: SELECT * FROM DEPARTMENTS WHERE DEPARTMENT_ID = &id=10
            Example: SELECT * FROM DEPARTMENTS WHERE DEPARTMENT_ID = &id='<ENTER SSN>'
            Example: SELECT * FROM DEPARTMENTS WHERE DEPARTMENT_NAME = '\&name='John Doe''
            Example: SELECT * FROM DEPARTMENTS WHERE DEPARTMENT_NAME = '\&name=John'
        FIX: Query Analzyer: Script parser: Statement with a quoted string that contained a linefeed,GO,linefeed would be split into two statements
        FIX: Parameterized Scripts: Parameter names with special were allowed, they are no longer allowed and are terminated if the name contains any character other then a-z/A-Z/0-9.
        FIX: Parameterized Scripts: Execute Edit now supports parameterized scripts
        FIX: Query Analzyer: Auto-Completion where a column was in a function with more then one parameter would cause the auto-completion to always complete with tables.
        FIX: Procedure Editor: A "--" client side comment in a quoted string would through off the parser.
        FIX: (Oracle) Create Table Dialog: Foreign keys would be created as DISABLED. (bug introduced in 4.6.10)
        FIX: (Oracle) Schema Browser: Foreign Key constraint sometimes had double identical values.
        FIX: (Oracle) Table Data Editor: SQL Generator for Date modifications now use TO_DATE('','YYYY-MM-DD HH24:MI:SS')
            instead of TO_DATE('','YYYY-MM-DD HH12:MI:SS PM') to prevent a syntax error when running ADS in Japanese locale

4.6.14: FEARURE: Schema Browser: Servers that don't have their passwords saved. When a user connects and specifies a username
            and password, ADS will now hold the username and password in memory until the user disconnects or closes ADS. The
            username and password will be used when openning a query window, tool or scripting.
        FEATURE: Added File->Options:General:Prompt for commit when auto-commit is OFF which will determine whether the
            application will prompt the user to commit if rows are modified and auto-commit is not enabled.
        FEATURE: (Oracle) Session Manager: Added column to session tab for SPID.
        FEATURE: (Oracle) Session Manager: Added in toolbar the MAXIMUM number of processes
        FIX: Query Analzyer: Executing a CallableStatement with .executeCallableQuery would not print out sql warnings.
        FIX: Parameterize Scripts: An "&" in a single quoted string without a leading "\" where it is not the first character
            in the single quote, a parameter dialog would prompt for a variable.
        FIX: (Oracle) Profile Dialog: editing or viewing profile would not set the "Expire in" correctly.
        FIX: (Oracle) Security Manager: User tab: Added columns "Locked Date" and "Expired Date"
        FIX: (Informix) Create Table Dialog: (Bug Introduced in 4.6.10) Prevented from creating table with VARCHAR/NVARCHAR because it required a precision and scale value

4.6.13: FEATURE: (Oracle) Session Manager: Added in toolbar the ACTIVE, INACTIVE and MAXIMUM number of sessions
        FIX: (SQL Server, Sybase, Sybase Any): ADS would not use the Statement.setMaxRows() to trunace rows because of a driver bug.
            This caused performance issues when quering on a table with large number of rows, even if the Max Rows was set to a low amount.
            ADS now analyzes the query and only uses Statement.setMaxRows() with statements that have a SELECT statement. 
        FIX: Parameterized Scripts: Client Side Comments are now not replaced or prompted for when executing script
        FIX: Parameterized Scripts: Parameter Dialog: parameters were not in order of occurance.
        FIX: Parameterized Scripts: Parameter Dialog: multiple parameters of the same name in a quoted string incorrectly replaced the values
        FIX: Parameterized Scripts: Parameter Dialog: Cancelling on the dialog would still execute the script.

4.6.12: FIX: Query Analzyer: Executing a statement when "Auto Commit" enabled, "Commit" and "Rollback" are not re-enabled after query completes.

4.6.11: FEATURE: Options:General: Added "SQL Server Quoted Identifier (Default)" and "Sybase Quoted Identifier (Default)" so the user may define the default value when registering a Sybase or SQL Server
        FEATURE: Query Analyzer: Parameterized Script: Ability to execute scripts with defined parameters.
            Parameters are defined by a leading "&". Parameters in quotes need to be escaped by "\".
            Example: SELECT * FROM DEPARTMENTS WHERE DEPARTMENT_ID = &id
            Example: SELECT * FROM DEPARTMENTS WHERE DEPARTMENT_NAME = '\&name'
            - Query Window toolbar: added "parameterized scipt" toggle button.
            - Options:Query Analyzer - Added option to specify default value of "Parameterized Script" for each database.
        FEATURE: (Oracle) Session Manager: Added USERNAME to the Session columns and the Grouping toolbar button.
        FIX: Query Analyzer: Query statment with a "--" server side comment at the end of the statment would prevent "Execute Edit" from executing.
        FIX: SQL Formatter: Formater didn't format statements wit "~" in it.
        FIX: SQL Formatter: Added "PLAN" as a keyword for line breaks.
        FIX: SQL Formatter: RIGHT, LEFT, OUTER, JOIN and ON where no uppercased when Uppercase Keywords option was on.
        FIX: Schema Browser: Performance increase on expanding nodes with large lists.  UI event update only fired once for all items, instead of firing event for each new node.
        FIX: (Oracle) Schema Browser: Optimized queries for folders Tables, Package Bodies, Package Functions & Procedures and Parameters.
        FIX: (Informix): Script Procedure/Function: Scripting Functions & Procedures with a script separator of ";" would include two ";" at the end of the CREATE statement.
        FIX: (Informix): Auto-commit being disabled would prevent the user to change the current database.
        FIX: (Informix): Extract Index: Informix 9.3 and above only supported 8 columns in index when up to 16 are supported.
        FIX: (PostgreSQL): Script CREATE Table: Tables with varchar columns without column size definition would script as "varchar(-5)"
        FIX: (Sybase): Constraint Scripting & Script Generator: Scripting Table w/ Constraints would generate CREATE INDEX for unique constraints.
        FIX: (Sybase): Script CREATE TABLE: Binded defaults were not scripted as a separate bind statement.
        FIX: (Sybase): Script Generator the order of CREATE DEFAULT and CREATE TABLE were not in the correct order.
        FIX: (Sybase): Script CREATE Table now contains LOCK DATAROWS, ALLPAGES, DATAPAGES syntax
        FIX: (SQL Server): Script CREATE TABLE: Binded defaults were not scripted as a separate bind statement.
        FIX: (SQL Server): Script Generator the order of CREATE DEFAULT and CREATE TABLE were not in the correct order.

4.6.10: REQUIREMENT: This build now requires Java 1.5, before update verify ADS is being run by Java 1.5 in Help->About:System:java.version
        UPDATE: Upgraded to JGraph Library 5.7.4.5 and JGraphLayout 1.2.2
        FEATURE: Table Data Editor: Option in Options:General:Table Data Editor - Option to disable transaction requirements for table data editor.  Some Informix databases my have transactions disabled. User may disable transaction requirements at own risk.
        FEATURE: Server Registration: Generic JDBC connections: When browsing file selection for drivers, user may now select multiple files at a time with Control-Click.
        FEATURE: (Oracle) Oracle DBA Tools now use threads and delayed tab quering to increase UI response time in case of long running meta data queries, and prompts user with "Searching ..." messages.
        FEATURE: (SQL Server 2005): Schema Browser: Added folders for Synonyms, System Views, Assemblies, XML Schema Collections, Asymmetric Keys, Certificates and Symmetric Keys
        FEATURE: (SQL Server 2005): Schema Browser: Added Schema name to objects in Datatypes, Rules and Defaults 
        FIX: Export Tool: When exporting a table (not a resultset) ADS will prequery (select count(*) from table) to get a total count of rows to be exported to make an exact estimate to completion.
        FIX: Server Registration: Components on General Tab would not resize with the window size.
        FIX: Schema Browser: Drag-n-Drop of servers from groups to groups didn't work since the new Shortcut Toolbar.
        FIX: Import/Export Tool: Average Row Time and Estimated time was calculated without fractions of a millisecond which had less time accuracy. Now time is calculated with 1/1000 of a millisecond accuracy.
        FIX: (Oracle): Script Constraint defintions, added support for Constraint state keywords ENABLE/DISABLE, RELY/NORELY and VALIDATE/NOVALIDATE
        FIX: (Oracle): Schema Browser: Previously didn't display tables based off of Object Types.
        FIX: (SQL Server 2005): Schema Browser, Logs only contained date. Now has full log.
        FIX: (Sybase): Openning a query window with no database context selected in schema browser now sets database to the user default.
        FIX: (SQL Server, Sybase, Sybase Any): Query Window Max Results affected UPDATE/INSERT statements row max modifications because of Driver bug.  Workaround now fixes issue.
        FIX: (Informix): Table Script CREATE definition.  VARCHAR and NVARCHAR datatypes with reserve values (ex: VARCHAR(3,1)) would be scripted with incorrect length values.
        FIX: (Informix): Script Generator: Scripting Functions & Procedures with a script separator of ";" would include two ";" at the end of the CREATE statement.        
        ADDED: SwingX Library by Sun Microsystems (http://swinglabs.org)  Source/License: http://download.aquafold.com/download/libraries/swingx/

4.6.9:  FEATURE: Server Registration: Oracle Connections: SID option: Service Name is now allowed by appending "SERVICE:" in front of the value, in which case ADS will use the new URL ServiceName format jdbc:oracle:thin:@//host:port/servicename.
        FIX: Oracle Connections: In build 4.6.8 I changed the connection URL to use the format jdbc:oracle:thin:@//host:port/servicename which prevented connections in certain scenarios. Now reverted back to old format.
        FIX: SQL Server 2005:
            - Database Visual Editing/Scripting: If a log file had a MaxSize = MAX_INT then the log file would not be included.
            - Triggers Schema browser/Scripting: Would not be visible or scriptable if the schema was not "dbo"
        FIX: Save Results: XML Format: Added encoding for ><&"' characters

4.6.8:  FEATURE: Oracle DBA Tools
            - Added DBA Tools for Oracle including: Instance Manager, Storage Manager, Rollback Manager, Log Manager, Security Manager,
                Session Manager, SGA Manager and Server Statistics
            - Application Menu bar now provides a list of Oracle DBA Tools.
            - Schema Browser context menu now contains Oracle DBA Tools menu for Oracle connections.

        FEATURE: Query Analyzer Permssions by Server Type {Production, Development & Test}.
            - Default Permissions: Added File->Options->Permissions to set the default permissions to a server connection by server type.
            - Server Connection Dialog: Added Permissions Tab to specify Query Analyzer permissions. Permissions are set by selecting Server Type, and are modifiable after server selection.
            - Query Analyzer: SQL execution is restricted depending on server permissions.
        FEATURE: Register Server: Username and Password may now be external application which provides the username or password in the StdOut.
            To specify an external application, wrap the value with a "~`" at the beginning and "`~" at the end of the value.
                Example: On Windows, the username or password value can be ~`cmd /c more "%HOMEPATH%\username.txt"`~ where username.txt has the username or password in it.
                Note: On Unix you may not execute scripts because the JVM has problems retreiving the StdOut when running a command shell (sh, bash), but binary executables work

        FIX: Toolbar Shortcuts: Allow shortcuts from any node
        FIX: (DB2) Table Data Editor: Enabled editing for LONG VARCHAR data types.
        FIX: (Sybase) Extraction: In some cases Unique Constraints where not extracted.  
        FIX: (MySQL) Extraction: Procedure & Functions with 0 parameters where the parameter brackets have a space in between Example: "( )" would not extract

4.5.16: FEATURE: Server Registration: Added button next to the Port field which will do a socket connection test on the host and port specified.
        FEATURE: SQL Formatter Options: Options Dialog now has a tab for the SQL Formatter options, including an option to allow for formatting to happen without the prompting the dialog each time.
        FEATURE: Visual Editing & Scripting for Storage & Security: Added quoted identifiers to SQL generation.
        FEATURE: Options->Scripts: Added "Visual Editing Quote Identifier" option to enable/disable quote identifiers in SQL generation while using Visual Editing.
        CHANGE: Options->Scripts: Changed options into grouped grid layout.
        FIX: Grid Results/Table Data Editor: HTML Text values where rendered as HTML in the cell of the grid.
        FIX: Syntax Color: '|' would not terminate keywords and prevent coloring of the keyword.
        FIX: Auto-Completion: A line comment that is after a table name where there is no space between the table and the comment would not include the table in autocompletion (Ex: FROM MYTABLE, YOURTABLE-- This line comment)
        FIX: Table Data Editor: Save Refresh wouldn't refresh (Bug Introduced in build 4.5.15)
        FIX: (Oracle) Show Execution Plan on AutoCommit:disabled: Executing wouldn't warn user transaction would be commited if the Explain Plan needed to CREATE/DROP the plan_table  
        FIX: (Sybase Anywhere): Script CREATE View, Trigger and Procedure would use the systriggers.trigdef and sysprocedure.defn catalog view to extract the trigger source instead of the systrigger.source and sysprocedure.source table.  The source was
            formatted slightly different. Source is now extracted from systrigger.source and sysprocedure.source
        FIX: (Sybase Anywhere 9): Unique and Check Constraints would script CREATE statements incorrectly under certain circumstances.
        FIX: (PostgreSQL 8.1) Security Permissions: Added support for the new makeaclitem() signature so that permissions would be supported.

4.5.15: FEATURE: Query Window: Added "Format Current Statement" and "Format Script" commands to automate menu.
        FEATURE: Table Data Editor: Added status bar which displays the format pattern of the current selected cell. Pattern is no longer displayed in the cell when editing a NULL value.
        FIX: Convert Binary to Hex: [File->Options->Results]: Blobs where not being converted to hex, only other binary datatypes
        FIX: Save Results: Saving to Excel Spreadsheet was limited to 32,767 rows. Increased to 65,536 and rows are broken up into sheets.

4.5.14: FEATURE: Auto-Completion: Added support for SHOW CREATE TABLE <TABLENAME> Syntax
        FEATURE: SQL Formatter: Added support for indenting Sub-Select statements
        FEATURE: (SQL Server 2005): Added schema folder to schema browser in database objects
        FIX: Table and Column drag-n-drop to editor was not working (broken after build4.5.10)
        FIX: Query Panel now shows all databases in combo box, and are not filtered the same as the schema browser 
        FIX: (Oracle): Oracle JDBC driver sometimes returns Date value for Timestamp column.  ADS was returning Err.
        FIX: (SQL Server 2005): Schema names other then dbo(database owner) where not showing up. Changed from using USER_NAME() to SCHEMA_NAME() in 2005

4.5.13: FEATURE: SQL Formatter: Added option to wrap line after X number of characters in a line.
                - Added option to align indent on AS and align on JOIN
        FEATURE: Application frame now saves maximized status when exiting and restores it at startup.
        FEATURE: (PostgreSQL): Added to Schema Browser a Procedure folder to list functions with a VOID return.
        FEATURE: (DB2): Support for Nicknames.  Added support to schema browser and for DDL scripting.
        FIX: Syntax Coloring: Single quoted strings incorrectly colored when preceeded by '-' (Ex: tdate-'01/01/2001')
        FIX: Grid Results: CTRL-Click on a column to select where the columns were moved around would cause the wrong column to be selected.
        FIX: SQL Formatter: SQL Statements which had column names starting with ORDER or GROUP would result in an empty string.
        FIX: (DB2) Syntax Coloring: Added keywords: MATCHED, OVER, PARTITION and Functions: ROW_NUMBER
        FIX: (Informix): Script Table: Decimal and Floats didn't have precision/scale values.

4.5.12: FEATURE: Added support for Object Filtering in the Schema Browser.  In the Server Registration under the Filter tab, there is now the ability to add filters to folders with wildcards.
        FEATURE: Added Wildcard filtering to Schemas and Folders in the Server Registration. *=wildcard, ?=any character
        FIX: Grid Results: Rearranging the column locations and then coping to clipboard would leave the data in the original order, but the headers in the new order.
        FIX: (Oracle): Editing source of Procedures/Packages where a '?' was in a quoted string and a commnet block had a single quote (with no matching quote) would save the '?' as ':1'.
                    Disabled in Oracle JDBC driver EscapeParsing with Statement.setEscapeProcessing() to fix this issue.

4.5.11: FEATURE: (Oracle): Storage Support ...
            - Visual Editing storage support for Tables, Indexes and Clusters.
            - Scripting support for storage for Tables (CREATE (Full)), Indexes (CREATE) and Clusters (CREATE).
        FIX: SQL Formatter: Now the statement separator is preserved instead of being replaced by GO.
        FIX: Import Tool: Now takes into consideration files which only use carriage returns to separate lines (Mac)
        FIX: Shortcut Toolbar: Renaming button would rename the path so shortcut wouldn't work properly
        FIX: (Oracle): Procedure Editor: Executing a procedure in a package with a parameter of type REF CURSOR would fail.

4.5.10: FEATURE: Shortcut Toolbar: Added support to drag a database as a shortcut.  When openning the query it will go to the database and open a query window to that database.
        FIX: Query Window Animated Icon: On OSX and on Java 1.5 on other OSs, after executing a query the CPU time for ADS was still high because of a Thread bug in Java related to animated icons.  Found work around.
        FIX: Script Formatter would append the last character of a script as a new statment if the last character in the script was a line feed.
        FIX: Shortcut Toolbar: Clicking shortcut will browse to server node, but will not expand the node, so it will not open a connection if the node is a server node.
        FIX: Table Visual Editor: Changing datatype from VARCHAR to NVARCHAR (or vice versa) with the same length would not generate a change.
        FIX: (Informix 10): Extracting Table with columns having "default ''" would fail because Informix 10 stores it as NULL.

4.5.9:  FIX: Opening a Query Analyzer with a Toolbar shortcut didn't allow the user to execute a statement.
        FIX: Opening a Query Window didn't allow a user to execute a query (related to animated icon for tabs)

4.5.8:  FEATURE: SQL Formatter: Added SQL Formatter that will format SQL statements according to specify parameters defined in an options dialog.
            - Added menu items "Format Current Statement" and "Format Script"
            - Added hot keys CTRL-B to format current statement and CTRL-Shift-B for format script
        FEATURE: Short Cut Toolbar: Added Shortcut Toolbar.  The empty, right side of the application toolbar accepts drag-n-drop actions.  If the user
            drags a server from the schema browser into the toolbar it will create a button/shortcut to that server.  If the shortcut is clicked, the
            application will automatically browse to that server and open a query window to it.
        FEATURE: Status bar: Application status bar now contains the path that is selected in the schema browser
        FEATURE: Editor: Copy and Cut action when there is nothing selected will perform the action on the current line.
        FEATURE: Query Analyzer: Added an animated icon to the tab of the query window when a query is executing.
        FEATURE: (SQL Server, Sybase, Sybase Anywhere, PostgreSQL, MySQL) Query Window: Added Connection ID to window toolbar.
        FIX: Auto-Completion: Added support for HAVING clause which would through the parser off
        FIX: Grid Results: Selecting all column values with CTRL-Click on column would not allow you to copy to clipboard
        FIX: (SQL Server) Query Window: If auto-on-all schemas was enabled and user was not database owner the description of the table would have the username as the schema name instead of dbo.
        FIX: (Oracle) Schema Browser & Extraction: NVARCHAR2 lengths were defined as byte length, not character length.
        FIX: (Oracle) Schema Browser & Extraction: Declared NUMBER datatype without precision or scale was scripting as (22,0) when it should be defined at all to define unlimited value.

4.5.7:  FEATURE: (MySQL 5): Added support for bit datatype
        FEATURE: (Sybase Any): Schema browser, added Events folder to support events.
        FEATURE: AutoCompletion: Added support for multi table column completion on aliased sub queries with multiple columns. Ex: "select SubTab.^ from (select * from table1, table2) SubTab"
        FEATURE: Added Option in File->Options:Grid Results[Copy to clipboard as default].  When coping numeric data to the clipboard,
            the numeric values will be copied completely instead of the formatted value is results format in case the format truncates data.
        FIX: AutoCompletion: Now supports Unicode characters (was broken with new parser)
        FIX: Cycling through tab windows with CTRL-TAB would not reset focus to editor
        FIX: Export Tool: Now does not right trim string values.
        FIX: (DB2): Converted almost all SYSIBM schema reference to SYSCAT references in extraction to better support DB2 variants other then DB2 for LUW(Linux/Unix/Windows)
        FIX: (Oracle): Extract Trigger was not appending the WHEN clause

4.5.6:  FEATURE: (Oracle) Auto-Completion: support for PUBLIC synonyms in the table list
        FIX: Auto-Completion: Column context was wrong when query contained '!'
        FIX: Script Generator: (Introduced in build 4.5.4) Would fail to extract tables without primary key.
        FIX: Table Data Editor & Query Results: String results now do not get right trimmed.
        FIX: (DB2 8.2): Stop removing CR/LF from queries in Visual Editing.
        FIX: (DB2): Visual Editing: Added support detailed error messages.
        FIX: (SQL Server) Change Database in query panel and the schema browser would fail if "Set Quoted_Identifier" is disabled in the Server Properties.
        FIX: (MySQL) Scripting Table CREATE Full would generate an extra CREATE INDEX for the primary key.
        FIX: (MySQL) Visual Editing now uses backtick quote identifier.
        FIX: (MySQL) Added "`Object Name`" quote identifier option to Import/Export tool, Script Generator and File->Options->Scripting

4.5.5:  FEATURE: Added CTRL-Y hot key to Delete Current Line
        FEATURE: Grid Results:
            - Column width and height are now calculated using the font metrics, which allows more flexible font settings.
            - Ability to highlight rows by selecting row columns.
            - Ability to select all cells in a column by clicking on column with CTRL hit pressed.
            - Added secondary column sorting capability.
        FIX: Auto Completion: Fixed more column context bugs.
        FIX: Syntax Coloring: Comments of // and -- with a leading character word, the word would be colored as the comments.
        FIX: Save Results: If data format of Excel is selected and the file browse is activated to select a file name without an extesion, .txt is appended to the file instead of .xls
        FIX: (Sybase) Script Table CREATE(Full): If table would have more then one trigger, it would add the trigger create to the script more then once.
        FIX: (Sybase Anywhere) Schema Browser: Didn't take into consideration case sensitive schema owners.  If user logged in as dba instead of DBA and
            SybaseAny server was configured for case-sensitive comparisons objects would not be listed

4.5.4:  FEATURE: Options->Results Format: Added the option of "[None]" so that the results are displayed in raw values.
        UPDATE: Updated to libraries JGraph 5.7.2, JGraphLayout 1.2.1.3, JGoodies 1.3.1 and L2FProd 0.2
        FIX: Save Results: HTML format of data didn't have a closing ">" on </FONT> terminator.
        FIX: Query Results: Added seconds to the default format of and Time/DateTime datatypes
        FIX: (DB2): Query Analyzer: Syntax coloring added for vendor keywords of ASSOCIATE, LOCATORS, IF, ELSEIF, LEAVE, LOOP, REPEAT, UNTIL, RESIGNAL, SIGNAL, WHILE, DO
        FIX: (DB2 8.2): Query Execution: Stopped removing CR and LF from queries, because IBM fixed the bug in 8.1 where queries failed when statement
            had a CR or LF in it.  This allows the saving of formatted query text in CREATE VIEW.
        FIX: (Sybase 11.5): Scripting Tables & Indexes didn't work because of lack of support for index_colorder() by Sybase 11.5
        FIX: (DB2): Execute edit didn't extract primary key on a SELECT where schema name didn't match because of case sensitivity
        FIX: (Informix) Import/Export/Save Results - Changed date/datetime format to work under any DBDATE formatted connection
                (ex: EXTEND(MDY(7,22,1999), YEAR to SECOND)+13 UNITS HOUR+59 UNITS MINUTE+0 UNITS SECOND)

4.5.3:  FEATURE: Enhanced Auto-Completion: Rewrote SQL Statement parser to support more complicated SQL syntax.
            - Auto-completion now supports UNION (and UNION ALL) queries.
            - Auto-completion now supports subqueries.
            - Auto-completion now supports ANSI JOINS and all modern JOINS at any depth.
            - Auto-completion now supports aliased query tables (eg SELECT SUBTABLE.* FROM (SELECT * FROM MYTABLE) SUBTABLE)
            - Auto-completion now supports for "where table.column=table." completion.
            - Auto-completion now supports column completion on tables/views with spaces in it with [] and "" quote identifiers.
            
        FEATURE: (Oracle) Query Window Auto-Describe: Added Table and Column Comments to description
        FEATURE: File->Options->Appearance:[Editor Background Color]: Added option to set the background color of the editor.
        FIX: Procedure Editor: The adding of "Save Query" made the procedure editor require a file to save to everytime a proc was compiled if there was no file defined.
        FIX: Script Generator: Ordered the creating of constraints in order of Primary Key, Unique, Check and Foreign Key, and Dropping in reverse order. 
        FIX: (SQL Server) Script Procedure EXECUTE: Variable declarations didn't contain length, precision and scale
        FIX: (Informix) Import Tool: Importing into a datetime column, ADS would format the date with a trailing ".0" which would cause a syntax error.
        FIX: (Sybase) Index Scripting & Script Generator: Scripting Table w/ Indexes would generate CREATE INDEX for Indexes that were supporting constraints.
            These indexes are automatically created and dropped with the constraint, so this is now removed.

4.5.2:  FEATURE: Procedure Editor: Added "Save Query" button to toolbar.
        FIX: (Oracle) Visual Edit & Scripting of View: Column aliases in the CREATE & CREATE OR REPLACE were not added.
        FIX: Query Results: Numeric fractions were truncated to 3 decimal values.

4.5.1:  FIX: Script Generator didn't take into account multiple tables with same names but different case.
        FIX: Visual Editing for DB2: Now uses double quote identifiers to generate SQL to support case sensitive object names.

4.5.0:  PACKAGING: Tagged current build as 4.5.0.
        PACKAGING: Created new installation packages and bundled with JRE 1.5 Update 4
        FEATURE: Visual Table Editor: Added support to rename column on Informix.

4.0.18: FEATURE: Postgresql 8.0 Function Extraction:  Parameter names are now extracted when generating a CREATE or CREATE/REPLACE statement.
        FEATURE: Script Generator
            - Ability to turn on Identity_insert values [SET IDENTITY_INSERT <table_name> ON] (SQL Server, Sybase)
        FEATURE: Import Tool
            - Ability to turn on Identity_insert values [SET IDENTITY_INSERT <table_name> ON] (SQL Server, Sybase)
            - Added the option "Object Quote Identifier" so the user may specify the option. The default value is the value specified in File->Options->Scripts.
        FEATURE: Export Tool
            - Ability to turn on Identity_insert values [SET IDENTITY_INSERT <table_name> ON] (SQL Server, Sybase)
            - Added the option "Object Quote Identifier" so the user may specify the option. The default value is the value specified in File->Options->Scripts.
        FEATURE: Script Table CREATE
            - MySQL - Support for ENUM and SET datatype values
            - MSSQL - Support for ROWGUIDCOL
        FEATURE: Visual Explain Diagram: Added "Save Image As" which allows the user to save the Diagram to JPG or PNG image format.
        FEATURE: ER Diagram Generator: Added to the tools menu "ER Diagram" which allows a user to extract tables and views from a database to generate and manipulate an ER Diagram.
        FEATURE: Visual Table Editor
            Oracle:
                - Ability to ALTER columns. Supports the ability to change the name, datatype/length, nullable and default value. (8i doesn't support renaming of columns)
            DB2:
                - Ability to ALTER columns. Supports the ability to change the datatype to VARCHAR or the length of a VARCHAR column. (This is the only ALTER column DB2 supports)
            SQL Server:
                - Ability to ALTER columns. Supports the ability to change the name, datatype/length, nullable and default value.
                - Support for ROWGUIDCOL                
            Sybase:
                - Ability to ALTER columns. Supports the ability to change the datatype/length, nullable and default value. (Sybase doesn't support renaming columns. Sybase 11 doesn't support renaming and changing datatypes)
            Sybase Anywhere:
                - Ability to ALTER columns. Supports the ability to change the name, datatype/length, nullable and default value. (Sybase Anywhere doesn't support the ability to change a NOT NULL to NULL)
            Informix:
                - Ability to ALTER columns. Supports the ability to change the datatype/length, nullable and default value. (Informix doesn't support renaming columns)
            PostgreSQL:
                - Ability to ALTER columns. Supports the ability to change the name, datatype/length, nullable and default value. (PG 7.3/7.4 doesn't support of changing datatypes. PG7.2 doesn't support changing datatypes or NULLs)
            MySQL:
                - Ability to ALTER columns. Supports the ability to change the name, datatype/length, nullable and default value.
                - Support for ENUM and SET enumeration values.
        FEATURE: Visual Editing (Oracle): Added support to CREATE/ALTER/DROP Clusters.
        FEATURE: Visual Editing (Oracle): Added support to CREATE/ALTER/DROP Array Type.
        FEATURE: Visual Editing (Oracle): Added support to CREATE/ALTER/DROP Table Type.

        FIX: MySQL Table CREATE Script: Default values where not being quoted with single quotes.
        FIX: MySQL Table Creating/Editing and Scripting: Didn't support precision and scale for INT datatypes and decimal/numerics.

4.0.17: FEATURE: Options: Added to File->Options->Results->[Convert binary to hex] which will convert all binary data retuned by query results to Hex values (This does not include BLOB or CLOB data). Default is set to TRUE.
                NOTE: MySQL users require the JDBC driver version 3.0.10 and above.
        FEATURE: Drag&Drop: Added support for drag-n-drop support for Indexes into the query window
        FEATURE: Query Analyzer for Oracle: Execute Explain while auto-commit is disabled and the explain table CREATE/DROP feature is enabled. Now displays a warning telling the user that the current transaction will be committed.
                - Also added option File->Options->Visual Explain->[Display Commit Warning] to allow the enabling/disabling of the warning.
        FEATURE: Save Results: Added a "Save to Clipboard" button to allow the user to save the result to clipboard instead of to file.  Change "Ok" to "Save to File"
        FEATURE: Script Generator:
            - Ability to go back and redo a script generation after it has completed or been cancelled.
            - Added support to script to preview window where a user can copy to clipboard.
        FEATURE: Import Tool:
            - Ability to go back and redo an import after it has completed or been cancelled.
            - Added support to script INSERT statements to preview window where a user can copy to clipboard.
            - Options Tab: Date&Time combo box: added "dd/MM/yyyy:hh:mm:ss" and "dd/MM/yy:hh:mm:ss" as options. Date combo box: added "dd/MM/yyyy" and "dd/MM/yy"
            - Saves current options, so that the next import the options will default to the last import.
        FEATURE: Export Tool:
            - Ability to go back and redo an export after it has completed or been cancelled.
            - Added support to export to preview window where a user can copy to clipboard.
            - Options Tab: Date&Time combo box: added "dd/MM/yyyy:hh:mm:ss" and "dd/MM/yy:hh:mm:ss" as options. Date combo box: added "dd/MM/yyyy" and "dd/MM/yy"
            - Saves current options, so that the next export the options will default to the last export.
        FIX: Print Dialog: Now the ESC and ENTER keys are bound to the Ok and Cancel buttons.
        FIX: MySQL 5.0 (requires 5.0.6+)Constraint Extraction/Scripting: Scripting didn't extract foreign key columns because MySQL didn't provide them until 5.0.6.  Fix requires MySQL 5.0.6 or above.
        FIX: MySQL 5.0 (requires 5.0.10+): Added Support for Triggers in the schema browser, visual editing and extraction/scripting.
        FIX: MySQL Script Table: decimals were not scripted with precision and scale.
        FIX: OSX 10.4: Look and Feel name was changed from "Mac OS X" to "Mac OS X Aqua" which caused ADS to incorrectly set the default Look and Feel to the Aqua Data Studio Look and Feel.
        FIX: Informix Scripting: Table CREATE(Full) was extracting the last trigger in the database, not the trigger for that table.

4.0.16: FEATURE: Query Analyzer & Procedure Editor: You may now drag and drop files from the Operating System desktop or file manager/ finder into the editors to be loaded.
        FEATURE: Query Results in Query Analyzer & Table Data Editor: Results of numbers and date are now formatted in accordance to the current locale (Regional Settings);
        FEATURE: Import Tool, Export Tool, Script Generator: Model dialogs are converted to a full frame which allows the minimizing and maximizing of the tool window to allow the continued use of ADS, which the tool runs.
        FEATURE: Script Generator: Option tab now has option to "Sort By Dependency", which will order the CREATEs taking into consideration object dependencies.
        FEATURE: Script Generator: Option tab now has option to "Include blank line between statements", which will place a blank line between statements in the script generated.
        FEATURE: Printing: Added new printing dialogs with extra capabilities and control to Query Anzalyzer, Procedure Editor and Explain Diagram.
        FIX: Sybase Script Index CREATE or Table CREATE (Full): Now supports ignore_dup_key, sorted_data, ignore_dup_row in the index CREATE statement.
        FIX: Query Analyzer: Execute Edit would not execute if a single table SELECT had a table name followed by a tab that is not extended.
        FIX: Script Generator: Setting plaform option to Windows wouldn't convert LF in the body of procedures to CR/LF when writing to file.
        FIX: Schema Browser (Sybase, SQL Server, Sybase Anywhere): Table/View columns where not sorted by ColumnID.

4.0.15: FEATURE: Server Registration: Support for setting Transaction Isolation Level in Advanced tab.
            TRANSACTION_NONE - A constant indicating that transactions are not supported.
            TRANSACTION_READ_COMMITTED - A constant indicating that dirty reads are prevented; non-repeatable reads and phantom reads can occur.
            TRANSACTION_READ_UNCOMMITTED - A constant indicating that dirty reads, non-repeatable reads and phantom reads can occur.
            TRANSACTION_REPEATABLE_READ - A constant indicating that dirty reads and non-repeatable reads are prevented; phantom reads can occur.
            TRANSACTION_SERIALIZABLE - A constant indicating that dirty reads, non-repeatable reads and phantom reads are prevented.
        FEATURE: Server Registration (SQL Server): Support for setting quoted_identifier, ansi_nulls, ansi_null_dflt_on, ansi_padding, ansi_warnings in Advanced tab.
        FEATURE: Server Registration (Sybase): Support for setting quoted_identifier in Advanced tab.
        FEATURE: About Box: Added JDBC Driver tab which displays a list of available JDBC drivers in the JVM and the version numbers.
        FEATURE: Procedure Editor Toolbar: Added "Open Script" button to the toolbar to allow a user to load the script for creating or modifying a procedure
        FEATURE: Upgraded JGraph 3.2 to JGraph 5.6.1
        FIX: Script Generator: Changed the DROP statements to script in reverse order of the CREATE statements
        FIX: DB2 Syntax Coloring: Added MERGE and MATCHING to DB2 syntax coloring keywords.

4.0.14: FEATURE: Script Generator: Allows user to Script the CREATE and DROP definitions of all/selected objects in a database, including INSERTs of data
            - Accessibility in Tools Menu -> Script Generator and Schema Browser Popup Menu Tools -> Script Generator
        FEATURE: Oracle Schema Browser: Added "Java Classes" folder to list all Java classes available in the schema.
        FEATURE: Oracle: Added ability to Script CREATE, REPLACE, ALTER and DROP of Array Types, Table Types, Object Types and Clusters
        CHANGE: Added ".PKS" and ".PKB" to Script Filter defaults in File->Options->[General:General]->Script Filters
        FIX: DB2 Script "Execute Bind": Sometimes would order parameters in the incorrect order.
        FIX: Oracle: Result columns with nested tables didn't display correctly.
        FIX: Text in Properties Dialog for Function, Procedure, Package, Package Body, Rule, View and Trigger is now copyable able to the clipboard.
        FIX: Text in Preview SQL tab in Visual Editing Forms is now not editable.
        FIX: Query Editor: Multi-Line comments were not completely syntax colored as quoted strings
        FIX: Oracle Editor: Added "ELSIF" keyword to syntax coloring.

4.0.13: FEATURE: Sybase: Added support for jConnect 6.0.  All that is required is to download and include the jConnect driver in the ADS classpath.
        FEATURE: (All Databases) Table Scripting: Added "CREATE (Full)" which will script a Table CREATE for the table, constraints, indexes and triggers
        FEATURE: (DB2, SQL Server, Sybase Anywhere, PostgreSQL, Informix) Proc Editor: Added "Execute Procedure" which allows user to execute the procedure currently being worked on.
        FIX: DB2 Script Table CREATE: Constraint definitions sometime included info from other schemas.
        FIX: Oracle Table Editor: Now shows GENERATED and USER DEFINED constraints.
        FIX: Oracle Table Editor: Extracting Primary Key and Updating table data from a SELECT statement where the table name doesn't use the same case values in the name is now fixed.        
        FIX: Oracle Schema Constraint Browser: Now shows GENERATED and USER DEFINED constraints.
        FIX: Oracle Server Registration (OCI Connections): Added detailed information when JDBC driver doesn't match Oracle Client Libraries.
        FIX: PostgreSQL Script Function CREATE/REPLACE: Added support for IMMUTABLE | STABLE | VOLATILE - CALLED ON NULL INPUT | RETURNS NULL ON NULL INPUT | STRICT - | SECURITY INVOKER | SECURITY DEFINER
        FIX: Register Server: Passwords with a space as the last characters had space removed when saved.

4.0.12: FEATURE: Memory Optimizations: Optimized the reclaiming of memory across query executions by the JVM
        FEATURE: Query Window for DB2 8.x: Warning messages now also contain the full descriptive messages.
        FEATURE: Register Server on Windows: (SQL Server - ODBC, Informix - ODBC, Generic - ODBC) contains browse button to browse the available ODBC data sources.  
        FEATURE: Oracle Table Scripting: Added support for Table and Column comments
        FEATURE: Oracle Table Scripting: Added "CREATE (Full)" which will script a Table CREATE for the table, comments, constraints, indexes and triggers
        FIX: Query Results: SQL Server: If a query execution returned an error and warnings the warnings were not displayed.
        FIX: Generic ODBC: Connecting to Navision database server would not allow to open a query window.
        FIX: Oracle Script Table CREATE: User defined check constraints with names starting with "SYS_C" were not scripted.
        FIX: Oracle Schema Constraint Browser: User defined check constraints with names starting with "SYS_C" were not listed.

4.0.11: FEATURE: Proc/Func Editors for SQL Server, Sybase Anywhere, DB2, PostgreSQL and Informix
            - Schema Browser: Popup menu on Folder nodes: Procedures, Functions contains "Create XXX in Editor" to open new editor.
            - Schema Browser: Popup menu on nodes: Procedure, Function contains "Edit XXX in Editor" to open editor for editing.
            - Editor allows user to create and modify procedures, functions within a tabbed editor similar to the Query Analzyer
            - Editor displays any compilation errors in a grid list. Double clicking on an error will highlight the appropriate line in the editor.
              (PostgreSQL required latest JDBC driver for correct line numbers: http://www.aquafold.com/download/jdbc-drivers/Postgresql/ )
        FEATURE: Query Window for DB2 8.x: Error messages now contain the full descriptive messages.
        FEATURE: Query Text/History Results: Status bar now contains "[Truncated by Max Results]" if any of the resultsets are truncated by the maximum results 
        FIX: DB2 Explain Plan: Missing icon for TQUEUE operation. TREE_EXPLAIN_SPOOL
        FIX: Informix Table Check Constraint Scripting: Check constraints with check text greater then 33 characters would produce multiple copies
        FIX: Informix Query Results: TEXT database was retreived as hex values.
        FIX: Syntax Coloring: Any string aligned with a quoted string not separated by a space was colored as a quoted text even if it wasn't in the quotes (eg firstname+'lastname')

4.0.10: FEATURE: Oracle Proc Editor: Added "Execute Procedure" which allows user to execute the procedure currently being worked on.
        FEATURE: Query Text/History Results: Status bar now contains resultset and row count
        FIX: Query Grid Results: Sorting on a string text column where all the data is the same didn't perform very well 

4.0.9: FEATURE: Oracle Editor for Procedures, Functions, Packages and Package Bodies
            - Oracle Schema Browser: Popup menu on Folder nodes: Procedures, Functions, Packages, Package Bodies contains "Create XXX in Editor" to open new editor.
            - Oracle Schema Browser: Popup menu on nodes: Procedure, Function, Package, Package Body contains "Edit XXX in Editor" to open editor for editing.
            - Editor allows user to create and modify procedures, functions, packages and package bodies within a tabbed editor similar to the Query Analzyer
            - Editor displays any compilation errors in a grid list. Double clicking on an error will highlight the appropriate line in the editor.

4.0.8: FEATURE: MySQL 5.0 Support
            - Schema Browser: Added Constraints, Views, Procedures and Functions
            - Scripting DDL: Added Scripting CREATE/DROP for Constraints, Views, Procedures and Functions
            - Visual Editing Schema: Added support to CREATE/DROP Views, Procedures and Functions
            - Visual Editing Security: Added User Database Privileges: Create View, Show View, Create Routine, Alter Routine, Create User, Execute

       FIX: Table Data Editor for Oracle: Doing an Execute Edit on a fully qualified table <schema>.<table> where schema case-sensitivity doesn't match, ADS will not allow to edit the table.
       FIX: Sybase Extract Table: Extracting tables with columns having comments would return multiple columns of the same column having the comments.
       FIX: Sybase Schema Browser & Constraint & Index columns Exctraction: Browsing and Extracting on a different users objects (other then dbo) would not show up.
       FIX: MSSQL Server Schema Browser & Constraint Exctraction: Browsing and Extracting on a different users objects (other then dbo) would not show up.
       FIX: MSSQL Table Exctraction: Extracting on a different users tables (other than dbo) would not show up.
       FIX: Query Results: If "Query Stats" are disabled and "Always display record count" is enabled, line feed formatting isn't always correct.

4.0.7: FEATURE: Query Analyzer: Added "Reconnect" button to the toolbar. Ability to reconnect if the connection has been lost.
       FEATURE: Text Results: Added to SQL Statement and Error message the script line number location in the script
       FEATURE: Text Results: Syntax Coloring for error messages and SQL statements
       FEATURE: Options: Added to File->Options->Results 1)Enable Syntax Coloring 2)Color for SQL Statements 3)Color for Error message
       FEATURE: Query Analyzer: Database combo box is now filtered according to Registration Filter.
       FEATURE: Results: Added new "Script Details" results, which may be enabled with the last button on the applicatin toolbar.
                Provides a list all statements executed in a script with an icon representing whether the execution was successfull, failed or with warnings.
                Also includes the SQL statement, message and beginning and ending line numbers.  A double click on an item will highlight the statement in the editor.
                The results column contain the number of resultsets and number of rows returned in the format X (Y) where X=#resultsets and Y=#rows

4.0.6: FEATURE: Visual Explain Tree - Added to popup menu "Save Column Positions" to allow the customization of the position of the explain node columns
       FEATURE: Option: Added to File->Options->Results:[Message Results] - Ability to enable the clearing of the message results prior to execution
       FEATURE: Query Analyzer (Sybase): Errors Results now have  Msg: X, Level: Y, State: Z ... Server: ServerName, Procedure: schema.procedure, Line: A

       FIX: Schema Browser for DB2: Columns where not sorted by physicall order.
       FIX: Schema Browser for Sybase Any 9.0: Constraints node didn't list constraints.
       FIX: Oracle 9i/10g Server Registration: Advanced tab, driver parameters didn't work.
       FIX: Schema Browser (SQL Server) - Sorted Jobs and Operators node

4.0.5: FEATURE: Grid Results: Popup menu now has "View As Text" to view multi-line CLOB/Text values
       FEATURE: Tools Menu: added "Explain Whiteboard" to allow activation of WhiteBoard without adding Explain plan.
       FEATURE: Explain Tree Results (Grid Results/Whiteboard): Added color coding support, including ability to enable/disable coloring in popup menu.
       FEATURE: Scripting Table Foreign Constraints (DB2, MSSQL Server): Now supports ON DELETE and ON UPDATE clauses.
       FEATURE: Visual Editing for Oracle: Now supports multi-case object names by using Quoted Identifiers.

       FIX: Explain Diagram: Property-Value table columns are not resized each time the user selects a different node in the diagram.
       FIX: Schema Browser (Sybase): Store Procedures are now displayed as <schema>.<name> instead of just <name>
       FIX: Schema Browser (Sybase, SQL Server, Informix): Triggers are now sorted 
       FIX: MySQL Schema Browser & Scripting: Added support for objects with names containing "-" in them.

4.0.4: FEATURE: Grid Results: Enabled the drag-n-dropping of selected cells.
       FEATURE: Table Data Editor: Added a "Edit in Window" command so users may edit CLOBs and large text fields with multi-line data.
       FEATURE: Visual Explain WhiteBoard: Right-Click Popup menu on Visual Explain results now have an extra item "Add to Whiteboard"
                - The whiteboard allows users to compare explain plans.  The plans may be moved/removed with the popup menu on the caption of each explain plan
       FEATURE: Visual Explain Color Coding for Critical Path, Critical Node and Critical Operations. The Explain Diagram now has support for color coding ...
                - Critical Path: This colors the critical path which is determined by the costliest sub-node of each node.
                - Critical Node: This colors the top 3 costliest nodes in the entire path.
                - Critical Operation: This colors the costliest operations. Level_1 = Cartesian Joins; Level_2 = Full Table Scans; Level_3 = Sorts
       FEATURE: Visual Explain Options:
                1. Moved Visual Explain Options from Results tab to new "Visual Explain" tab
                2. Added options for default value of Color Critical Path, Critical Node and Critical Operation for Oracle, DB2 and SQL Server
                3. Added options to specify background/foreground colors for nodes in Critical Path, Node and Operations

       FIX: Oracle Schema Browser: Procedures & Function nodes under Package and Package Bodies didn't refresh with the "Refresh" command.
       FIX: Oracle EXECUTE BIND: Executing a Procedure with a REFCURSOR parameter that was of both IN and OUT value would through exception.
       FIX: Oracle EXECUTE BIND: Executing a Procedure with a IN/OUT REFCURSOR would not print resultset correctly.
       FIX: Enabled "Display SQL" didn't display the SQL in the Messages Results. Also, now SQL displayed only has a top line separator of "---------------"
       FIX: File Mnemonics: Added _M_ to "Mount Directory" and _U_ to "Unmount Directory".
       FIX: Grid Results: Columns with no names would not have correctly calculated widths. For columns with no names, the name "column[colposition]" is now displayed.

4.0.3: FEATURE: Save Results: HTML Formatted Results: Hyperlinks are now wrapped with <a href> to create hyperlinks in the HTML document.
       FEATURE: Options: Added File->Options->Results:[Script Execution:Stop On Error] which determines whether the execution of a script stops if an error occurs on a query execute.
       FEATURE: Visual Explain: Tree table (grid) results now have tooltips for each explain node.
       FEATURE: Visual Explain: Diagram nodes now have more detailed information.
       FIX: SQL Server: Scripting Functions,Procedures&Triggers: In certain cases Scripting would not work if the name of the proc or function was too long.
       FIX: Save Results to Excel Format: Data in cell is now stored as correct datatype for numbers, dates, times and boolean values.
       FIX: Save Results to Delimited Data: {tab} and {space} separators were not saved correctly.

4.0.2: FEATURE: Aqua Data Studio Look and Feel: Made toolbars to have rollover buttons, which also makes the toolbar a little smaller.
       FEATURE: Options:Text Results: Added in File->Options-Results:Text Results the ability to enable and disable the display of the SQL statements executed in the text results (Default is FALSE).
       FEATURE: Save Results: Enhanced Save Results to have the following new features:
            1. After clicking the save button of the Save Results dialog, the dialog is closed and the user is not notified that the data is saved.
            2. The options of the last save results are stored and used for the next save results.
            3. The path of the last saved results is automatically set in the file path when activating a save results dialog.
            4. Ability to save results to an Excel Worksheet
            5. Ability to save results to INSERT statements
            6. Ability to include the SQL Statements in the results
            7. Saving the results to HTML and Excel will use the File->Options->Results:Grid Results for alternating background colors
            8. Added the ability to include the row count in the results
            9. Added the ability to save the results of an explain plan
            10. Enhanced the look and formatting of the HTML document saved

4.0.1: FIX: Informix Registration Dialog: Driver Properties didn't work.

4.0.0: Package Release:
	 Updated all JDBC drivers to latest versions from vendors.
	 Updated JRE to version 1.4.2_07
       Updated added License directory to include files with licenses for JDBC drivers from vendors and libraries used by ADS.

3.7.24: FEATURE: Register Properties Dialog: Now has an advanced tab.
            - Advanced tab has driver properties for all database types where a user may specify driver parameters
            - Advanced tab has Characterset combo box for Sybase.
        FEATURE: Register Properties Dialog for Sybase Anywhere now has Database field so user may specify the database to connect to.
        FIX: MySQL Results for tinyint(1) would return as [Err].

3.7.23: FEATURE: MS SQL Server 7.0 & 2000/5 - Added Windows Authentication
            - Added Option: "Windows Single Sign-On" option to allow a user to login using Windows Authentication with the currently logged in username/password of the Windows OS. (Only supported on Windows OS)
            - Added Option: "Windows Authentication" option to login using Windows Authentication with the specified username/password. (Only Windows Authentication Option supported on non-Windows platforms (Linux, OSX, etc)
            - Requires latest jTDS Driver 1.0 with ntlmauth.dll (http://www.aquafold.com/download/jdbc-drivers/jTDS/)
                - copy jtds.jar to location (<ADS_INSTALL>\lib\jtds.jar)
                - copy ntlmauth.dll to root ADS directory (<ADS_INSTALL>\ntlmauth.dll) 

        FIX: MySQL 4.1 Schema Browser for Table didn't show columns and indexes.
        FIX: MS SQL Server Registration: Host name for instances now supports "hostname\instance" in addition to "\\hostname\instance"
        FIX: MS SQL Server Schema Browser & Query Analyzer db combo box: Now only lists the databases which the user has access to.

3.7.22: FEATURE: Schema Browser for Oracle: To Package and Package Body nodes, added functions and procedures to allow the browsing within the package and to script EXECUTE and EXECUTE BIND
        TESTING: Tested database version support for Oracle 10g, DB2 8.2, Postgresql 8.0, Sybase Anywhere 9, MySQL 4.1 (5.0-Alpha), MS SQL Server 2005
        FIX: Schema Browser Drag-n-Drop: Added ability to drag-n-drop Procedures, Functions and Parameters to Query Window.
        FIX: MySQL Schema Browser: 4.1/5.0 - Process Info List didn't show the list of processes.
        FIX: SQL Server 2005 Schema Browser/Constraint Extraction: Didn't list or extract check constraint.
        FIX: Sybase Anywhere 9 Schema Browser/Constraint Extration: Didn't list or extract check constraint.

3.7.21:
        FEATURE: Variable Binding: Query Scripts: Added 3 client side commands to support execution of stored procedures with variables binded to parameters.
            - Added commands variable, print, println and executeCallableQuery. (Use Procedure->Script Object->EXECUTE BIND to generate example syntax)
            - .println (.print) - Syntax: .println { variable_name | 'text value' }, ... n
            - .variable - Syntax: .variable <variable_name> datatype [, value]
            - .executeCallableQuery - Syntax: .executeCallableQuery 'parameter_name<datatype,{in | out | inout}>[, ...]', <LINE_BREAK>
                                                { CALL <PROCEDURE_NAME>( ? { , ? ... } ) }
                                                { ? = CALL <PROCEDURE_NAME>( ? { , ? ... } ) }

        FEATURE: Schema Browser: Script Procedure: Added Script EXECUTE & EXECUTE BIND
        FIX: SQL Server: Table Editor: Generated date formats with "YMD", which didn't work in all locales.  Format is now set with SET DATEFORMAT
        FIX: Execute Edit: Didn't work when query contains character "ß" (eg Straße (street)). This character becomes "SS" when converted to uppercase.
        FIX: Sybase Anywhere 9: Extract Constraints didn't work.
        FIX: Postgresql: Drop Function sometimes didn't work, depending on whether the parameters were extracted in the correct ordering.

3.7.20: FEATURE: Oracle Visual Editors for View, Trigger, Procedure, Function, Package and Package Body: Added "Show Errors" button to display errors for source of invalid object
        FIX: SQL Server: Show Explain Plan: When Show Explain Plan was enabled and a multi-result select query was executed, not all resultsets were displayed
        FIX: Main application title still contained last file openned even after last query window was closed.
        FIX: Scripts Browser: Showed all files.  Now only shows files with extensions defined in File->Options->General
        FIX: Sybase: Executing Procedure which returns row counts and an error message produces a "getUpdateCount" error message instead of the actuall error message.
        FIX: SQL Server: Table Data Editor: UNIQUEIDENTIFIER columns are now editable.
        FIX: DB2 Function/Procedure Scripting: Added support for external functions/procedures
        FIX: SQL Server: Introduce Value Stubs: Months in the date were zero based.  Changed to one based.

3.7.19: FEATURE: Dialog Windows: Converted border of Titled Borders from single black line to Etched Borders for a better look.
        FEATURE: Message & Confirmation Dialogs: Now have Mnemonics enabled for hot key actions.
        FEATURE: History: Selecting text into Query Window now selects all of the selected statements and not just the current statement
        FEATURE: History: Added "Save Script" toolbar button which saves all currently selected statements into a file.
        FEATURE: Application & Query Toolbars are now 16x16 size.
        FEATURE: Text Results Options: Added "Always display records effected" as an option which will display "records effected" even if Display Query Stats are off.
        FEATURE: Script Browser: Folders and Files are now sorted
        FIX: Text Results: When 'Display Query Stats' are OFF the Record Count results prints extra line feed.
        FIX: Sybase Index Extraction: On HP/Unix: Unique and Clustered flags not retreived. The ANDing of Hex values doesn't work on Sybase HP/UNIX. Converted queries to use ANDing decimal values.
        FIX: MS SQL Server & Sybase Anywhere: Extraction of Procedure/Function. Trimming spaces from procedure lines could cause problems if line doesn't end with line feed
        FIX: Grid Format of NULLs: NULL value formatting was not being displayed in Grid Results.
        FIX: Query Analyzer: Alt-D hot key only worked for the last query window openned
        FIX: Query Analyzer: Multi-Panel View - CTRL-E didn't work while in a results tab
        FIX: Grid Results: Sorting for numeric/date data types was broken in build 3.7.18

3.7.18: FEATURE: Editor: Added Windows shortcut keys for Cut: Shift+Del / Copy: Ctrl+Ins / Paste: Shift+Ins
        FEATURE: Table Data Editor: Added refresh button to only refresh the data, but not save. [In case the Max Results is changed]
        FEATURE: Table Data Editor: Inserting Date/Time and setting NULL now affects all selected cells, not just the current.
        FEATURE: Import/Export Tool: Added "yyyyMMdd" and "yyyyMMddHHmmssZ" date/datetime formats
        FEATURE: Query Analzyer & Popup menu: Added CTRL-SHIFT-DELETE short-cut for Clear Document.
        FEATURE: Table Data Editor: Added File Menu with Hot-Keys
        FIX: Table Data Editor & History Toolbars: Changed Toolbar button/icon to 16x16 instead of 20x20
        FIX: Script Index CREATE: Multi-column Index would omit columns after the first one.
        FIX: Grid Results: Formatting of Grid Results was broken in build 3.7.15
        FIX: Import Tool: Informix 7.3 doesn't support quoted qualified columns
        FIX: Query Analyzer in MultiTab results: Fixed focus of components as CTRL-TAB cycles through query windows.
        FIX: Unclosed single and double quotes in server side comments caused parser to disregard statement separators. fixed. (was fixed in 3.5.13, reintroduced in 3.7.1)
        FIX: Displaying of Query Stats: Added "Command was executed successfully" into the query stats to be enabled/disabled, which is displayed when a statement is executed and zero records where modified
        FIX: Import Tool: Importing files with spaces between comma separated columns (eg: column1, column2) would add a space to the beginning of column string data.
        FIX: Schema Browser: Oracle Packages, Package Bodies and Java Sources. Queries are now based on ALL_OBJECTS.
        FIX: Option "Do Not Prompt to Save For New Scripts": was not working when opening and creating new files.
        FIX: Sybase Indexes: Extracting and Viewing didn't work for non-capitalized Indexes.

3.7.17: FEATURE: Query Analyzer: Added option in File->Options->[General] to enable MultiTab query results where the editor is the first tab and the results come after.
        FEATURE: Window Menu: Added option to enable the toggling of the current Query Analyzers MultiTab/SplitPane mode.
        FEATURE: CTRL-1 HotKey: Cycles through Query Window Results
        FEATURE: CTRL-ALT-(RIGHT/LEFT ARROW) Focus back and forth between the Tree View and the Query Tab View
        FEATURE: Grid Results: Popup menu, added "Copy w/ Headers", "Copy w/ RowCount" and "Copy w/ Headers & RowCount" to allow the coping of the selected text with the headers and a row count column
        FEATURE: Grid Results: Added option in File->Options->[Results] to specify alternating colors in grid results, including the option to set the background and foreground colors of the alternate row.
        FEATURE: Query Editor and Text/History/Message Results: Added "Clear Document" option in the popup menu to clear all document text.
        FEATURE: Text Results: Added option in File->Options->[Results] to enable/disable the displaying of the Warning headers along with the Warnings.
        FEATURE: Query Analyzer Window: Added Window Menu with options to Hide/Unhide the Query Toolbar and Query Results.
        FEATURE: Query Analyzer: Openning a Query Analyzer window will automatically set the current database according to the database selected in the schema browser
        FEATURE: Application: When closing the application the Dialog prompt to Save files will also have "Discard All".
        FEATURE: Closing Query Windows: Added option in File->Options->[General] to allow the ability to specify if ADS prompts a user to save a modified query window that doesn't have a file associated with it.
        FEATURE: Popup menu on Query Analyzer tab now includes "Close All" and "Close Others"
        FEATURE: Window Menu: Added option to Hide/Show application toolbar (CTRL-F8)
        FEATURE: Schema Browser: Added to popup menu "Refresh" - F5 to allow a user to refresh the node without collapsing/expanding the node
        FEATURE: Schema Browser: Added to popup menu "Script Object -> SELECT (*)" to Tables to generate a SELECT statement with '*' as the fields instead of the column names listed.
        FEATURE: SQL Server Query Analyzer: When openning a new query window, the connection will be set by default to the default database assigned to the user. This will only be overridden if the user currently has selected a different database in the schema browser.
        FEATURE: SQL Server Query Analyzer: When openning a new query window, the connection will be set by default to the default database assigned to the user. This will only be overridden if the user currently has selected a different database in the schema browser.
        FEATURE: Editor: Auto-Comment: If a text selection is made, the CTRL-/ will do a block comment around the selected text, instead of a line comment
        FEATURE: To Upper/To Lower: If no selection is made then the command will apply toUpper/toLower to the current word based on the caret position.
        FEATURE: Morph to Upper/Lower: The toUpper/toLower now do not change single or double quoted text
        CHANGE: Introduce Value Stubs: For MS SQL Server and UniqueIdentifier datatypes, the value stub is now NEW() instead of ''.
        FIX: Auto-Complete on Synonym columns stopped working after build 3.7.7
        FIX: Auto-Complete: Bug which caused auto-completion to only show "Please Wait ..." and nothing else, now fixed.

3.7.16: FEATURE: Auto Completion: Supports customization of auto completion in File->Options->[Editor] ... Auto Popup, Auto Popup Delay, Instant Substitution, Maximumn Pane Size, Minimum Pane Size
        FIX: Default for Instant Substitution in Auto Completion is now false
        FIX: Auto Completion: Tab key now closes completion window after completing if there is only one item in the window.
        FIX: Import/Export and Save Results Dialog: Added [Default] item for encoding types.
        FIX: Sybase: Database Devices: Support for Visual Editing and Scripting of devices larger then 2G.

3.7.15: FEATURE: Option Dialog - Converted option settings to PropertyPanels
        FEATURE: Syntax Coloring: Supports coloring of System Tables.
        FEATURE: Syntax Coloring (File->Options->[Editor]): Added ability to enable/disable and set the syntax color for keywords, vendor keywords, datatypes, functions, system tables, comments and quoted strings
        FIX: Execution of empty string when trying to change database on databases which don't have the concept of databases.
        FIX: Generic JDBC/ODBC Connections: .setMaxRow() is not supported by some JDBC/ODBC drivers (SQLite) which caused ADS to fail on queries.
        FIX: After closing last query window, give focus to Schema/Script Browser.
        FIX: Postgresql: Script Function or Visual Edit Function incorrectly generated parameter type definition for datatype varchar by placing a '()' after the varchar.
        FIX: Schema Tree: Move (Drag/Drop): You may now move servers to the root 'Database Server' node.
        FIX: SQL Server/Sybase: Script Alter and Alter of Procedures/Functions which had comment blocks before the CREATE statement would not work.

3.7.14: FEATURE: Postgresql 8.0 - Visual Edit User/Role: Added permission options for tablespaces
        FEATURE: Option Dialog: Changed the Tabbed View to an Outlook Tabbed View (aka Firefox/Intellij Option Dialog Look)
        FEATURE: Auto-Reconnect: Implemented Auto-Reconnect for Schema Browser, Visual Editing and SQL Scripting. (Postgresql requires latest JDBC driver, and Informix is not supported by Driver)
        FIX: Oracle Schema Browser Table Node: Filtered Tables that start with BIN$ for Oracle 10g which are the tables in the Recycle Bin
        FIX: Oracle Scripting Constraints: Added constraint state to the DDL which was being omitted for primary key, unique and check constraints.
        FIX: Query Stats: Added hot key to enable/disable ALT-SHIFT-R;
        FIX: Oracle Export Tool: Timestamp columns with precision would cause export to not work.
        FIX: Large Resultsets/Out of Memory: ADS now has error checking for running out of memory while quering for very large resultsets
        FIX: Editor: Find & Replace would replace multiple times according to how many times it had been used, which cause problems if the find string was a substring of the replace string.

3.7.13: FEATURE: Added File->Options->[Results] tab with 4 options: Max display size of columns, Display Query Stats, Max retrieval size of BLOBs and Max retrieval lines of CLOBs
        FEATURE: Added File->Options->[Editor] tab with 3 options: Expand Tabs to spaces, Number of Spaces in Tab expand and Size of Tabs.  These settings allows for automatic Tab/Space conversion in the Editor
        FEATURE: Syntax Coloring: Added Keywords for security related SQL statements
        FEATURE: Postgresql 8.0 - Tablespaces: Added support for tablespaces: Schema Browser, Visual Editing and Scripting DDL
        CHANGE: DB2/Sybase/MS SQL Server Schema Browser - Dependancies Node: Converted the Dependant Object Node to the actual object node so the objects have context sensitive menus and object icons
        CHANGE: Applied refactoring to source to enhance speed of key function calls and streamline database support infrastructure for new databases and database versions.
        FIX: Oracle Scripting Foreign Keys: Added constraint state to the DDL which was being omitted.
        FIX: Oracle Schema Browser: Added the "PUBLIC" schema folder in the schemas.
        FIX: Oracle Visual Editor for Users/Roles: System Privilege list is now specific to the database version 8i/9i/10g
        FIX: Oracle Visual Editor for Users/Roles Object/Column Permissions: Tables/Views/Columns have the appropriate index/references columns for User/Role and version type of database
        FIX: MS SQL Server Visual Editor for Object Permissions: Separated Scalar and Tabular functions for permissions.
        FIX: Index View Properties: Was displaying the datatype of the column incorrectly.
        FIX: DB2 Schema Browser - Dependancies Node: Added query to include Procedures that are dependant on the table
        FIX: Query Analyzer: Quering and displaying large BLOBs would lockup ADS.

3.7.12: FEATURE: Visual Editing for Security:
            DB2: Users, Roles, Object Permissions, Column Permissions
            Informix: Users, Roles, Object Permissions, Column Permissions
            MySQL: Users, Object Permissions, Column Permissions
            Oracle: Users, Roles, Profiles, Object Permissions, Column Permissions
            Sybase Anywhere: Users, Roles, Object Permissions, Column Permissions
            Sybase: Logins, Server Roles, Users, Roles, Object Permissions, Column Permissions
            MS SQL Server: Logins, Server Roles, Users, Roles, Object Permissions, Column Permissions
            Postgresql 7.4/8.0: Users, Roles, Object Permissions  [Column Permissions not supported by Postgresql]
            Postgresql 7.2/7.3: Not Supported
        FIX: SQL Server schema browser, column node: Was displaying length of NCHAR and NVARCHAR twice the size.
        FIX: Postgresql: Added support for Implicit Case-Sensitive schema objects

3.7.11: FIX: Mac OSX Look and Feel - Background of application was beening set to light gray.
        FIX: Informix Synonyms mapped to objects in different database: Added support in displaying them in the schema browser, scripting the SQL and added to auto-completion.
        FIX: Schema Browser for Oracle/Sybase Anywhere - Sorting Procedure and Function folder.
        FIX: MS SQL Server Query Results: values of tinyint columns where being displayed incorrectly.

3.7.10: FEATURE: Schema Browser - Drag-n-Drop: User may now move or copy (CTRL-Down) a server registration from folder to folder by dragging and dropping a server registration node.
        FEATURE: Schema Browser - Drag-n-Drop: User may now drag-n-drop a Table/View or Column from the schema browser to the Query Window. (ALT-Down will add item with a ", " prepended)
        FIX: SQL Server Case Sensitivity: Stored Procedure & Function schema extraction and visual editing didn't work on SQL Servers with case sensitivity
        FIX: Informix Queries on System Catalogs now explicitly query on the informix schema (eg informix.systables)
        FIX: Informix Syntax Coloring: Added RESOURCES, STATISTICS, HIGH, MEDIUM, SUBSTR

3.7.9:  FIX: CLOB data type: Multi-Line CLOB values were converted to single line values in Text Display and Import/Export Tool.
        FIX: Table Editor for Postgresql - Numeric & Decimal types now support Precision and Scale.
        FIX: Script Table CREATE for Postgresql - Numeric & Decimal types now support Precision and Scale.
        FIX: MySQL & Postgresql: Import/Export Tool and Table Data Editor now escapes backslash to a double backslash when generating string values in INSERT statements

3.7.8:  FEATURE: Browsing the Schema & Script browser with the keyboard will automatically scroll the pane to the selected entry.
        FEATURE: Visual Table Editor for Sybase: Added ability to drop columns
        FEATURE: Scripting Columns for Sybase: Added ALTER and DROP columns
        FEATURE: Look and Feel: Added optional command line parameter called ads.forcelaf which allows users to set their own look and feel with command line option of "-Dads.forcelaf=<full class path of Look and Feel>"
        FIX: Table Editor for Oracle OCI connections: Didn't set the correct database and schema which prevented the creation of a table
        FIX: Execute Explain (CTRL-Shift-Enter): was treating all comments as client side comments which removed Oracle Hints before execution.
        FIX: Generic Schema Browser: Schema Filter wasn't working.

3.7.7:  FEATURE: Export Tool: Tool allows user to export data results from query or table into delimited data or INSERT statements.
        FEATURE: Schema Popup Menu: Now has Tools->Import/Export menu item for context sensitive import/export functionality.
        FEATURE: Import/Export Tool: Scripting INSERT statements now has an optional statement separator for the script.
        FEATURE: Import/Export Tool: Scripting INSERT statements now use the configured scripting options for identifiers and statement separator
        FIX: View/Alter Table for DB2: Identity value was displayed incorrectly for columns with a column check constraint.
        FIX: Syntax Coloring for Postgresql: Multi-line/Single quoted text is colored as if it was not single quoted for support of CREATE Procedure syntax coloring

3.7.6:  FIX: MS SQL Server Script & ALTER View: Views over 4000 characters were trucated.
        FIX: DB2 Column Check Constraints: Column check constraints created with GENERATED ALWAYS AS (CHECK) were not being scripted.
        FIX: Look and Feel: Setting a Look and Feel not supported (e.g. Windows LaF on Linux) would prevent ADS from starting.
        FIX: Visaul Editing Dialogs:  Mapped the BACKSPACE ("Delete" on OSX) key to delete columns.

3.7.5:  FIX: Import Tool: Import was removing "[" and "]" from strings in certain cases.
        FIX: Table Editor [MSSQL Server]: UNIQUEIDENTIFIERS were not being single quoted when generating SQL statement
        FIX: FIX: Block Syntax Coloring: Block Syntax Coloring was not terminating on "**/".
        CHANGE: Query Analyzer Window: Now contains the name of the connection in the title.
        CHANGE: Added ALT-D hot key in Query Analyzer window which gives focus to the Database Combo Box to remove the need to use the mouse to change database.

3.7.4:  FIX: Create/Alter Table: Combo Boxes in detailed column info were not editable, such as "Default"
        FIX: Import Tool: Negative numbers for numeric columns were being imported as positive values
        FIX: Authentication Dialog when making a connection on registered servers without passwords saved, the username was disabled.

3.7.3:  FEATURE: OSX Look and Feel: Added the ability to change the application font for the OSX look and feel. Default of Lucida Grande size 11
        FEATURE: Schema Popup Menu now has the option "Query Analyzer as ..." which will prompt the user for a username/password before openning a connection for the Query Analyzer.
        FEATURE: Schema Browser Table Node: Popup Menu now has the option "Table Data Editor (Top 1000)" to easily edit table data without writing SELECT statements and execute edit.
        FIX: Oracle w/ Oracle 10g JDBC Drivers were getting the time of a DATE field truncated.
        FIX: Stored Procedure Extraction: If Stored Procedure contained parameters with an opening '(' and no space before the procedure name, the '(' was truncated.

3.7.2:  FEATURE: Integrated the Netbeans Editor v3.6 from v3.32
        FEATURE: Added ALT-X hotkey to map to Execute
        FEATURE: Auto-Completion is now threaded.  Long running auto-completions display popup
                 with "Please wait" until completed, with the ability to cancel.   (Feature in new Netbeans Editor v3.6)
        FIX: Double Clicking on the last word in the text doesn't highlight (Fixed in Netbeans Editor)

        FIX: Block Syntax Coloring: Block Syntax Coloring was not displaying correctly if a '/' was in the block comment.
        FIX: PostgreSQL: Resultset returns NULL for CIDR datatypes.

3.7.1:  FIX: Import Tool: The reported number of records imported on the status tab was one higher then actually imported.
        FIX: Import Tool: Files with a blank line at the end of the file displayed a blank line in the sample record grid.
        FIX: Import Tool: If CR/LF not included as part of the last line, the last character is truncated.
        FIX: File->Options[Format] -> DataType formats where limited to the list.
        FIX: Parser: If server side comments for "--" was enabled and disabled for "//" and a single quoted "/" was in the comments, the comment was truncated
        CHANGE: Added the APPLICATIONNAME, PROGNAME and HOSTNAME connection parameters to SQL Server and Sybase connection types
            so process info displays what application is being used.

3.7:    CHANGE: Changed Version 3.5.25 to 3.7 for Packaged Release

3.5.25: FEATURE: Visual Editing for Storage:
            DB2 8.1: Tablespaces, Containers
            Oracle: Tablespaces, Datafiles, RedoLogs, Rollback Segments, Controlfiles, Archive Logs
            MSSQL Server: Databases, Backups
            Sybase: Caches, Dump Devices, Database Devices, Databases
            Informix: Databases
            MySQL: Databases
            PostgreSQL: Databases

        FIX: Reading of SQL Scripts in Unicode-16bit didn't work
        FIX: DB2 Schema Browser: Stored Procedure & Functions are now sorted
        FIX: MS SQL Server Import Tool: If User didn't have access to any database the tool would not work.
        FIX: DB2 8.1 Schema Browser: Some fix pack versions of 8.1 return the schema with padded spaces.
        FIX: Oracle XMLType: Added support for XMLType. Requires xdb.jar and xmlparserv2.jar

3.5.24: FEATURE: DB2 Sequence Support: Schema Browser, SQL Scripting and Visual Editing
        FEATURE: Import Tool: Allows to add a new table while importing using the column info of the imported file
        FEATURE: Edit Menu: Added Redo and Select All commands
        FIX: OSX: Key mappings for Redo, Undo and Select All use the Apple Key instead of the CTRL key

3.5.23: FEATURE: Visual Editing for Sequences, Synonyms/Aliases, Defaults, Rules and Data Types

3.5.22: FEATURE: Visual Editing for Indexes, Stored Procedures, Functions, Views, Triggers, Packages and Package Bodies
        FIX: Added "Double Precision" as a datatype for Sybase.  Visual Table Editor and Result Formatting.

3.5.21: FEATURE: Visual Table Editor: Added more error validatation
        FEATURE: Visual Table Editor: Added autocompletion to the combo boxes.
        FIX: Table Data Editor would hold an open transaction after a "Save Refresh" until the window was closed.  Fixed.
        FIX: Informix: Script Table CREATE: Default Values for CURRENT on DATETIME/INTERVAL didn't have the extended date fractions
        FIX: MySQL: Table Extraction now supports PRIMARY KEY constraints for Table Data Editor, Visual Table Editor and Table Scripting

3.5.20: FEATURE: Visual Table Editing: You may now CREATE, ALTER and DROP table from the popup menu on the schema browser
        FEATURE: Postgresql: Added System Views and System Functions to separate user and system objects.
        FEATURE: Syntax Coloring: Added more keywords support for all databases.
        FEATURE: Scripting Table CREATE now supports Default Values
        FEATURE: Scripting Table Columns are now supported {CREATE, ALTER and DROP}
        FEATURE: Scripting Postgresql - Script CREATE OR REPLACE FUNCTION added
        FEATURE: Scripting refined to support visual editing
        FIX: Informix schema browser & extraction failed to extract "char(x) not null" datatypes
        FIX: Informix queries on datatypes of "datetime hour to second" failed
        FIX: Informix datatime variations: formatted correctly and allowed to edit on Table Data Editor

3.5.19: FEATURE: DBA SQL Scripting: Scripting on Storage, Security and Management Objects.
        FEATURE: About Dialog: Adding 3 tabs: System, Fonts and Charsets.

3.5.18: FIX: Fixed CLOB results display support for all database types.  Also enabled Table Editor support for CLOB datatype on appropriate datatypes.
        FIX: Informix: Scripting Trigger would script the trigger body out of order.
        FIX: Query Text Results panel would turn grey after Describing a table and then executing a query.

3.5.17: FEATURE: Import Tool: Added date format preview on Option Tab and added variety of formats
        FEATURE: Import Tool: Added combo box of file column names in the Table Column table or the Format Tab
        FEATURE: Encoding: Added new encoding support for scripts and results
                "Big5 - (Big5, Traditional Chinese)",
                "Big5_HKSCS - (Big5 with Hong Kong extensions, Traditional Chinese)",
                "EUC_JP - (JISX 0201, 0208 and 0212, EUC encoding Japanese)",
                "EUC_KR - (KS C 5601, EUC encoding, Korean)",
                "GB18030 - (Simplified Chinese, PRC standard)",
                "GBK - (GBK, Simplified Chinese)",
                "ISO2022JP - (JIS X 0201, 0208, in ISO 2022 form, Japanese)",
                "ISO2022KR - (ISO 2022 KR, Korean)",
                "SJIS - (Shift-JIS, Japanese)",
                "TIS620 - (TIS620, Thai)",
        FIX: PostgreSQL 7.3+ - Scripting, Auto-Completion/Automation didn't work on certain tables which had columns/indexes removed from them.
        FIX: PostgreSQL 7.3+ - Scripting CREATE of a Trigger Function would fail with new JDBC driver.
        FIX: PostgreSQL 7.4+ - Schema Browser - Moved information_schema.<tables> to system table folder

3.5.16: FEATURE: Added 'Window' menu which allows to show and hide the server browser, grid results and query toolbar.
        FEATURE: Import Tool: Added time/performance statistics to status tab.
        CHANGE: Forced the 'Auto On All Schema' settings to OFF on all databases.
        FIX: Import Tool: Made demlimiter editable so any delimiter can be specified.
        FIX: If only grid resuls and execution plan is enabled, then the execution plan results were always selected after execution. Fixed
        FIX: Auto-Completion on SELECT statement.  If a column name that ended with "FROM" was in the SELECT statement, columns after that would auto-complete. Fixed
        FIX: Query results for Oracle CLOBs didn't display correctly. Fixed
        FIX: Table Editor didn't allow modifications of Oracle CLOBs. Fixed

3.5.15: FEATURE: Added Data Import Tool in Tools menu.
        FEATURE: Sybase Schema Browser: Added Storage folder which contains Database Device, Dump Device and Cache browser folders.
        CHANGE: Connection Dialog: Changed the "Sybase 12.5 - TDS 5.5" title to "Sybase 11.x-12.5 TDS 5.5"
        CHANGE: Save Results Dialog: Changed "Double quote values" check box to a combo box to specify "Quote Identifier".  Values will be quoted and characters in value matching the quote identifier will be escaped.
        FIX: Auto-completion wasn't working when table name or alias ended with line feed. Fixed

3.5.14: FEATURE: New and Enhanced Look And Feels: Enhanced Default 'Aqua Data Studio' Look and Feel.  Added 'Aqua Data Studio - 3D' and 'Aqua Data Studio - XP' Look and Feel. Look and Feel may be changed in Option->Appearance[Tab]
        FEATURE: Visual Explain Diagram: On the tree-grid results of a explain plan you may right-click on the results for a menu that allows the user to bring up a new frame with a diagram representation of the explain plan.
        FIX: Visual Explain Tree: Fixed color of tree and made tree expandable and collapsable.

3.5.13: FIX: Unclosed single and double quotes in server side comments caused parser to disregard statement separators. fixed.
        FIX: Execute Current was not sending Server Side Comments to the server.  Comments on Stored Procedures would be lost by Execute Current on creating a procedure.
        FIX: Informix 7.3: 1) Schema Brower: Removed functions and datatypes which are not supported by 7.3.
                           2) Trimmed whitespaces returned on object names.
                           3) Fixed scripting of stored procedures which didn't work on 7.3, and polished scripting of tables, view and indexes
        FIX: Postgresql: Added REPLACE, RETURNS and RENAME keywords to syntax highlighting.
        FEATURE/FIX: Extended "Auto on all Schemas" to include table autocompletion.  "Auto on all schemas" will autocomplete on all schemas for both tables and columns.
        FIX: "Auto on all schemas" - Changed default to OFF instead of ON for all databases.

3.5.12: FEATURE: Added new connection type of "Informix 7.x-9.x - ODBC" to support Informix through an ODBC datasource.  Also, renamed
            "Informix Dynamic Server 9.3" connection type to "Informix 7.x-9.x"
        FIX: Sybase: Script Table was not scripting the "NOT NULL" section of a column correctly. Fixed.

3.5.11: FEATURE: Options -> Added support for enabling whether the schema browser displays the Server Type on the browser {Production/Test/Debug}
            Option->General Tab includes a check box to enable this feature. The default value is disabled
        FEATURE: Options -> Added Optional support for ";" statement separators.
            Option->General Tab includes a check box to enable this feature. The default value is disabled.

3.5.10: FEATURE: SQL Server Named Instances - When registering an SQL Server you may specify in the Hostname text the name of the
                SQL Server and the Instance name in the format \\ServerName\InstanceName without a port to enable an Instance connection.
                NOTE: This requires the latest jTDS JDBC Driver from http://www.aquafold.com/download or jtds.sourceforge.net
        FIX: Grid Formatting of Nulls - Nulls on the grid were not displaying according the the set format
        FIX: Saving Results - Formats of grid results are now saved in the same manner as displayed
        FIX: Sybase 11.0.x-11.4 - Fixed Schema Browser for Indexes, Constraints, Processes, which didn't display the objects.
        FIX: Sybase 11.0.x-11.4 - Fixed Scripting of Tables, Indexes and Contraints - This version of Sybase doesn't support CASE statements in SQL or index_colorder() built-in function.

3.5.9:  FIX: Oracle 8.0.6 doesn't support the SYS_CONTEXT() method to get sessionid, which was causing ADS to fail on results. Fixed by using GUID instead of sessionid

3.5.8:  FEATURE: Results Formatting.  Option dialog has formatting tab to specify the formatting of numbers and dates
        FEATURE: Schema Browser Filters: Filters for Schemas/Databases and Database Objects
        FIX: Changed "Sybase ASE 12.5 - TDS 4.5" text in connection dialog to "Sybase ASE 11.x-12.5 - TDS 4.5"
        FIX: Infrequently the text results panel becomes grayed out and unusable, mades some changes to hopefully prevent this.

3.5.7:  FIX: DB2 Visual Explain - Fixed query that retreived DB2 explain data, which was causing incorrect visual explain.
        FIX: DB2 Visual Explain - Fixed retreiving of explain data resultset bug which occured in DB2 8.1 Fix Pack 2

3.5.6:  FIX: Execute Explain now defaults results to the explain plan
        FIX: Schema Browser Table Columns - Data type precision and scale in the schema browser columns and column autocompletion window now are formatted correctly according to CREATE TABLE syntax.
        FIX: DB2 Explain Plan - fixed tree display which was not displaying the tree correctly.
        FIX: Explain Plan - Added a subtree and node cost column, with the cost column including the percentage of the total cost.
        FIX: Explain Plan - Prioritized columns in order of importance.

3.5.5:  FIX: Fixed Visual Explain for "MS SQL Server - ODBC" connections which didn't work.
        FIX: Visual Explain for Oracle - moved columns Cost, Cardinality and Bytes to beginning
        FIX: Fixed "Execute Explain" for MS SQL Server which didn't work.
        FIX: If there are any errors while processing Explain information, the errors are displayed in the text/message results
        FIX: OSX - CTRL-Click would not open popup window as right click, but CMD-click would.  Changed so CTRL-Click opens popup and CMD-Click doesn't

3.5.4:  FEATURE: Support for Visual Execution/Explain Plans (with Tree-Grid results) for Oracle, DB2 and MS SQL Server
        FIX: DB2 8.1 Registration: Chaned the default port text to 446 instead of 50000, which is the port the JDBC driver attempts to connect to if a port is not included.
        FIX: Changed the layout manager of the Multi-Grid query results to have a better look.
        FIX: Removed Unicode JDBC parameter from MySQL Connections

3.5.3:  FEATURE: DB2 8.1 Schema Browser - Added "Containers" node to the tablespace node to display containers of a tablespace. Added "Management"
            node to top level which contains detailed information on Connection and Lock information.
        FEATURE: Added support to script objects to Current Window, New Window and Save As to a file.
        FIX: MySQL Connections : Added unicode support by passing unicode and UTF-8 parameters to JDBC connection
        FIX: Table Editor did not work when editing on a SELECT * FROM SCHEMA.TABLENAME.  It would contruct the table name incorrectly in the UPDATE, INSERT and DELETE statements
        FIX: Server Registration: Server Type and Script mount was not being saved when Registering a new server or server cloned.
        FIX: Server Registration: You may now register a server even if you are not able to connect to the server.  ADS will prompt the user with the message ... "A connection to this server has failed.  Do you wish to register anyway?"
        FIX: Informix connections do not set the username and password on connection if they are blank, to support trusted connections.

3.5.2:  FEATURE: Register Server - Now able to define whether a Server is of type [Develop, Test and Production/Live], which will provide
            the appropriate icon for the server in the schema browser and query windows.
        FEATURE: Register Server - Ability to mount a scripts folder that can be browsed in the schema browser under the registered server,
            so that scripts can be accessed easier, and associated to a specific server.
        FIX: Auto-Completion now supports ansi-join syntax "table1 join table2".
        FIX: Auto-Completion now supports Quoted Identifiers

3.5.1:  FEATURE: Added cancel granularity in the prepare text of a query.  Cancelling a query while preparing text will cancel immediately.
        FIX: The Table Editor now uses the quoted identifiers and schema when generating SQL for changes, when appropriate.
        FIX: MySQL table editor - Enabled ability to edit columns with the TEXT, TINYTEXT, MEDIUMTEXT and LONGTEXT datatypes
        FIX: MS SQL Server table editor - Enabled ability to edit columns with the NTEXT datatypes
        FIX: Introduce Value Stub values for dates and time are now the current date and time.

3.5:    CHANGE: Changed Version 3.0.29 to 3.5 for Release

3.0.29: FIX: OSX CTRL/Apple Hot Keys - All CTRL hots keys are now mapped to Apple hot keys.  The CTRL-C/X/V/Z and Delete keys in the editor work correctly
        FIX: Query analyzer - double clicking on a word containing underbar characters doesn't highlight the entire word

3.0.28: FEATURE: Scripting - Added Scripting for Sequences on Oracle and Postgresql
        FEATURE: Scripting - Added Scripting for Packages and Package Bodies for Oracle
        FEATURE: Support for Synonyms & Aliases in Informix & DB2 ... Describe, Table Editor, Auto-Completion and SQL Automation now supports Synonyms/Aliases

        FEATURE: Added following Option settings:
            1. History - Option for specifying the max # of lines in the text history results
            2. History - Option for specifying the max # of lines in the text message results
            3. Scripting - Option for identation size on scripting DDL and DML
            4. Scripting - Option for Statement separator {GO, /} in multi statement DDL and DML scripting
            5. Scripting - Option for specifying the Quote Identifier for objects in the DDL and DML scripting "",[]
            6. Scripting - Option for Fully Qualifing object with schema in DDL and DML scripting
            7. Comments - Option for specifying which comments are Client & Server Side Comments:  --, //  or /* */

        FIX: Saving a file when closing a Query Window would fail.  Fixed.
        FIX: Saving a file with Save As or creating a new file, would not append a default 'SQL' extension if the user didn't specify an extension.

3.0.27: FEATURE: Scripting - Added Scripting for Databases on Sybase, SQL Server, Informix, Postgresql and MySQL
        FEATURE: Informix - Added KEYWORDS to syntax coloring ... RENAME, MODIFY and TO
        FEATURE: Save Results - Added option to allow user to specify the line-divider to be 'Windows (CR/LF)' or 'Unix (LF)', with 'Windows (CR/LF)' being default on Windows and Unix on all other platforms

3.0.26: FEATURE: Scripting - Added Scripting for User/Group(Roles) for Sybase, MS SQL Server and Informix
        FEATURE: Scripting - Added Scripting for Defaults/Rules on Sybase and SQL Server and Rules on PostgreSQL
        FEATURE: Oracle 9i - Support for the new TIMESTAMP/TZ/LTZ data type
        FIX: Execute Edit worked on the entire current statement.  Now, it works on the selected text first ... and the current statement if nothing is selected

3.0.25: FEATURE: Scripting - Added Scripting for Synonyms/Aliases on DB2, Informix and Oracle.
        FEATURE: Schema Browser Synonym/Alias Node - Added the name of the corresponding object to name of the node
        FEATURE: Data Type Scripting on DB2, Informix, Sybase Anywhere, Sybase, SQL Server, PostgreSQL
        FEATURE: Schema Browser Data Type Node - Added the name of the corresponding base datatype
        FEATURE: Syntax Coloring - Added keywords for Synonym/Alias/Data Type scripting
        FEATURE: Syntax Coloring - Added a more complete list of keywords for MySQL
        FIX: Informix Server Registration - If database registered was not sysmaster, then Query window would not open.
        FIX: Sybase Stored Procedure Parameter node didn't show parameters of the stored procedures.

3.0.24: FEATURE: Sybase Anywhere - Added 'System Tables' and 'System Views' nodes to the Schema Browser on Sybase Anywhere.
        FIX: Sybase Anywhere - Column and Table names are trimmed for metadata queries in auto-completion and schema browser for Sybase ASA 6.x

3.0.23: FIX: If a script is being modified and another script is double-clicked for open, there is no prompt to save the current script.
        FIX: The first click on grid results column now sorts the column in ascending order instead of descending.
        FIX: If no Primary Key or Unique Constraint is defined on table being edited, then user is not prompted to select one
        FIX: "Message" Results tab did not have the display set to the last appended message in the document. Now display is always set to the bottom.
        FIX: Build 3.0.22 introduced bug which didn't allow the saving of results ... FIXED
        FEATURE: Added support for Openning and Saving files in different Encoding types
        FEATURE: Added support for new Encoding types for Saving Results and Files, to include all of the following ...
                "ASCII - (American Standard Code for Information Interchange)"
                "Cp1250/Windows-1250 - (Windows Eastern European)"
                "Cp1251/Windows-1251 - (Windows Cyrillic)"
                "Cp1252/Windows-1252 - (Windows Latin-1)"
                "Cp1253/Windows-1253 - (Windows Greek)"
                "Cp1254/Windows-1254 - (Windows Turkish)"
                "Cp1257/Windows-1257 - (Windows Baltic)"
                "ISO 8859-1 - (Latin Alphabet No. 1)"
                "ISO 8859-2 - (Latin Alphabet No. 2)"
                "ISO 8859-4 - (Latin Alphabet No. 4)"
                "ISO 8859-5 - (Latin/Cyrillic Alphabet)"
                "ISO 8859-7 - (Latin/Greek Alphabet)"
                "ISO 8859-9 - (Latin Alphabet No. 5)"
                "ISO 8859-13 - (Latin Alphabet No. 7)"
                "ISO 8859-15 - (Latin Alphabet No. 9)"
                "KOI8-R - (Russian)"
                "UTF-8 - (8-bit Unicode Transformation Format)"
                "UTF-16 - (16-bit Unicode Transformation Format)"

3.0.22: FEATURE: Performance - Memory consumption decreased by ~33% on Queries and Speed Increased on Queries.
        FEATURE: Scripting - Added Scripting for Indexes and Constraints, including constraints for Table Scripting
	    FEATURE: Syntax Coloring - New Keywords related to Constraint and Index Scripting
        FEATURE: Schema Browser Top Index Node - Added the name of the corresponding table to name of the node
	    FEATURE: Schema Broswer Index Node - Added columns node to specify the columns in the index and sorting order
	    FIX: DB2 Schema Browser - Table Index Node did not include all indexes.
	    FIX: Query Analyzer Popup Windows were being reclosed when closing ADS, causing a double prompt to save working data.
	    FIX: Top File Menu (Automate) - Converted Mnemonic to "A" - "Execute Parse" hot key changed to Ctrl-Alt-A
	    FIX: Current Result Tab was not saved on requeries when "History Text" is the currently viewed tab

3.0.21:  FIX: Printing on OSX failed to print
	 FIX: When closing a query window and prompted to save the file, if Save As is selected but then cancelled, the query window will closed.  Now the window does not close.
	 FIX: Changed Query Timer format in Query Analyzer to hh mm ss
	 FIX: Changed the default max history for SQL history to 5 (from 0)

3.0.20:  FEATURE: Added Constraint Node in the Schema Browser (under the table node) for Informix, MySQL, Oracle, PostgreSQL, Sybase Anywhere
	 FEATURE: Added Print capabilities from the Query Analyzer.  You may print SQL Scripts and SQL results with the CTRL-P hot key

3.0.19:  FEATURE: Query Analyzer Window - Allows user to open a separate frame window for Query Analyzer
	 FEATURE: Text Result History - a text result panel which displays continues to append the text results to the previous results
	 FIX: When saving query results, the encoding used is saved as the default encoding for future saves.
	 FIX: Introduce Columns, Qualified Columns, Value Stubs on SQL Server and Postgresql didn't work when operating on a table that wasn't owned by the user logged in.

3.0.18:  FIX: PostgreSQL 7.2.x - Script SELECT, CREATE and DROP didn't work

3.0.17:  FEATURE: ADS now support DBMS_OUTPUT for Oracle by displaying the output in the text results. You may enable/disable it on the main toolbar
	 FEATURE: Full support for PostgreSQL 7.3 and above
	 FIX: Table Editor didn't work on PostgreSQL 7.3 and above.
	 FIX: Made the top toolbars non-floatable.
	 FIX: Select All and Copy to clipboard from grid results didn't work very well with large resultsets.
	 FIX: ADS was not cancelling any running queries when exiting.  ADS now cancels all running queries before exiting.

3.0.16:  FEATURE: When executing a query, the status bar now includes a [real] time elapsed executin time of the query.
	 FEATURE: Optimized the speed and memory of query execution with text results.  Text results take up less memory and display much faster
	 FIX: When registering a Server, the server name allowed users to specify special characters.  The server name must be a valid filesystem name.  This would cause ADS to fail.  ADS now prompts the user.
	 FIX: Table Editor for MySQL 4.0 didn't work for tables that were not all uppercase ... because of MySQL's case sensitivity.

3.0.15:  FIX: Option Dialog didn't come up if there was a problem retreiving Fonts from the OS (specifically on OSX).
	 FIX: Table Editor on SQL Server had editing of the TEXT datatype disabled ... now it is enabled

3.0.14:  FIX: SQL Server and Sybase allow for Databases with Spaces, but ADS didn't support them ... now ADS supports them.
	 FIX: DDL Trigger scripting for Sybase didn't retreive full source for large triggers.
	 FIX: DDL Trigger scripting for Microsoft SQL Server didn't retreive full source for large triggers.
	 FIX: DDL Procedure & Function scripting for Informix didn't retreive full source for large sources.
	 FIX: DDL & DML Scripting for Views didn't work for Sybase
	 FIX: DDL & DML Scripting for System Tables on MS SQL Server didn't work.
	 FIX: Removed Square Icon from first column of the grid results that specified the grid was not sorted.

3.0.13:  FIX: DDL Scripting for Microsoft SQL Server Functions and Stored Procedures.  CREATE and ALTER didn't work.  Now Fixed.

3.0.12:- FEATURE: Trigger, Procedure and Function nodes in Schema Browser now support DDL scripting for CREATE, REPLACE, ALTER and DROP
	 FEATURE: Schema Browser: Top level Trigger Folder now contains Trigger nodes with the Table name which the trigger is on.

3.0.11:- FEATURE: Table Editor now supports UNIQUE constraints.  If there is no Primary Key, then a UNIQUE constraint is used for setting the primary keys.
	 FEATURE: View Node in Schema Browser now supports SQL DML and DDL for SELECT, CREATE and DROP
	 FEATURE: Sorted the Database/Schema Object Nodes in the schema browser in a consistent manner across databases in priority of important (Tables, Views, Synonyms/Aliases, Indexes, Triggers, Procedures, Functions ...)
	 FEATURE: Informix Schema Browser: Added Function and Top Level Indexes Folder
	 FEATURE: Postgresql Schema Browser: Added Function and Top Level Indexes Folder
	 FEATURE: MS SQL Server Schema Browser: Added Top Level Indexes and Triggers Folder
	 FEATURE: Sybase Schema Browser: Added Top Level Indexes and Triggers Folder
	 FEATURE: Sybase Anywhere Schema Browser: Added Top Level Indexes and Triggers Folder
	 FIX: Table Editor on Sybase only allows a save once, and then fails on any other attempts.
	 FIX: Script Parser removed comments within quotes (eg 'LK--%', the parser would remove --%'), now fixed.
	 FIX: Generic-JDBC driver - Schema Browser would not show Tables and Procedures if the database didn't support Schemas, now fixed

3.0.10:- FIX: Script Table Create on Oracle didn't always put the precision and scale for NUMBER data type
	 FIX: Account for null JDBC Driver MetaData when connecting to a server

3.0.9: - FEATURE: Table Node in Schema Browser now supports SQL DML and DDL scripting for SELECT, INSERT, UPDATE, DELETE, CREATE, ALTER and DROP
	 FEATURE: Auto-Describe now supports Identity info for databases supporting Identity data type.
	 FIX: Informix 7.3 - Index folder for tables in Schema Broswer did not show the Indexes.

3.0.8: - FEATURE: Execute Edit / Table Editor - Now supports PUBLIC Synonyms for Oracle
	 FEATURE: Column Auto-completion now supports PUBLIC Synonyms for Oracle.  Table Auto-completion will NOT
	 	display PUBLIC Synonyms because there are too many default defined PUBLIC Syononyms by Oracle.
	 FEATURE: SQL History

3.0.7: - FEATURE: Table and Column Auto-completion now has support for Synonyms.
	 FEATURE: Table Editor/Execute Edit now supports Synonyms.  If you execute edit on a Synonym it will edit the table the Synonym maps to
	 FEATURE: Auto Describe now supports Synonyms
	 FEATURE: Introduce Columns, Qualified Columns and Value stubs now support Synonyms
	 FIX: In 3.0.6 if you tried to close the application it would not close. [Only if you downloaded an early build]
	 FIX: If Table Editor is invoked on a SELECT statement which doesn't select the Primary Key, then execption was thrown when trying to save changes.  Warning is now displayed.
	 FIX: Removed debugging info being printed on console/terminal window

3.0.6: - Windows Authentication and Trusted Connection support:
	   - New connection types. SQL Server 2000 - ODBC, SQL Server 7 - ODBC and Generic - ODBC.  With these connection types
	   - you may connect to SQL Server using Trusted Connections
	 FIX: In Table Editor, if a cell was changed, then cleared, then changed again, the data would be set to null

3.0.5: - FEATURE: Added "Select All" to the popup menu of the Grid Results which selects all the rows in the grid
	 FEATURE: While executing a script or statement, the status bar now shows more detailed status of the status of the execution
	 FEATURE: The initial focus at application startup is now the schema tree
	 FIXED: "Copy" in the popup menu of the Grid Results only worked when there was one grid result.
	 FIXED: If OS Environment doesn't contain USER_HOME variable then ADS would not be able to save any settings and would not run. ADS now prompts the user to set the USER_HOME
	 FIXED: OSX - The header on the Grid column looked funny. Fixed, and also changed icon to a black arrow.

3.0.4: - FIXED: Informix column auto-complete was padding the name to 18 characters. Now the column name is trimmed.
	 FIXED: MySQL v 4.0 database names are case sensitive, and 3.x are not.  Made ADS current database support for MySQL case sensitive.
	 FEATURE: Opening a Query Analyzer window sets the current database to the database currently being browsed on the schema tree.
	 FEATURE: Tabs now have an X button to close an individual tab

3.0.3: - Added Copy command to right-click menu on Grid results.
       - When auto-commit is enabled, the commit and rollback buttons are now disabled.
       - Made result pane smarter.  If message tab is the current tab but no messages then show text or grid. If grid is current, but has no results, then show text or message tab.
       - Added all SQL92 Keywords to Syntax Coloring for all databases types
       - Testing the Query Analyzer cancel button on sample databases. Trying to cancel a query while waiting on the database server to return from an executeQuery() command.
		Oracle 8i/9i - WORKS
		Postgresql - WORKS
		Sybase Anywhere - WORKS
		Informix - WORKS
		Sybase - WORKS
		MS SQL Server 7.0 - WORKS
		MS SQL Server 2000 - WORKS
		MySQL - doesn't cancel
		DB2 7.1 - doesn't cancel
		DB2 8.1 - doesn't cancel
	- Added Option to change the font of the SQL Editor
	- Shell scripts, change the line: ADS_HOME=. into: ADS_HOME=`dirname $0` for datastudio.sh and datastudio-bundled.sh
	- Fixed SQL Server and Sybase schema resolution.  If <USERNAME>.TABLENAME doesn't exist, then use dbo.TABLENAME
	- When Register a MySQL Server, the default database is set to 'mysql' if one is not specified
	- Display error when unable to change current database.
	- Support for Informix 7.3 by not quering on sysxtdtypes table for schema extraction
	- OSX - File->Exit (Alt-F4) is now File->Quit (Meta-Q) on OSX
	- OSX - Made the default fonts for OSX: Editor: Monaco/10 Text:Monaco/10 Grid:Helvetica/12 which are more readable
	- OSX - Buttons in dialogs now look like OSX buttons for OSX Look and Feel
	- OSX - Buttons in dialogs are now centered for OSX Look and Feel.

3.0.2: FIXED: Sybase Table Editor only worked on tables with all UPPERCASES.
       FIXED: Fixed some more issues with connecting to Sybase database with Roman-8 character set.
       FIXED: Postgresql TEXT datatype was not editable.

3.0.1: Enabled Execute Edit button to enable the Table Data Editor

--- Start 3.0 ---
DB Support
-------------
1. Native Support for Informix Dynamic Server 9.3
2. Native Support for Sybase Anywhere 8.0

Options
--------------
1. Ability to select which fonts to use in the application
2. Ability to specify Look and Feel of the application, including native OSX Look and Feel
2. Ability to specify the default behavior on saving passwords for registered servers

Register Server
----------------
1. Allow multiple file selection with the browse button and to save the previously selected directory for Gen-JDBC.
2. Option to not save password ... (this does not store the password on disk or memory)
3. Added Driver Parameter Option for Sybase 12.5 and Sybase Anywhere, this is to be used when connecting to a Sybase Server with Roman 8 Character set with a driver param of ?charset=iso_1

SQL Writing Automation
------------------
1. Introduce Select Stmt - This will insert a new SELECT statement and place the cursor to the table postion
2. Introduce Insert Stmt - This will insert a new INSERT statement and place the cursor to the table postion
3. Introduce Update Stmt - This will insert a new UPDATE statement and place the cursor to the table postion
4. Introduce Delete Stmt - This will insert a new DELETE statement and place the cursor to the table postion
5. Introduce Columns - This will insert a list of columns for the tables in the current query
6. Introduce Qualified Columns - This will insert a list of fully qualified columns for the tables in the current query.  If the tables are aliased the the table name will be the alias.
7. Introduce Value Stubs - This will insert a list of value stubs for the columns of the tables in the current query.  '' for CHAR values, 0 for numeric values and NULL for all others.
8. Comment Statement - This will comment out the current statement by wrapping with /* */
9. Comment Line - This will comment out the current line with a //
10. Uncomment Comment - This will uncomment the current comment, by removing the /* */, // or the -- slash comments
11. Morph To Upper Case - This will convert the current statement to upper case
12. Morph To Lower Case - This will convert the current statement to all lower case.
13. Delete Word - Ctrl-Backspace will now delete the current word

Query Analyzer
--------------
1. Ability to have files with no extension show up in the script browser (currently exceptions are thrown)
2. Right-click Query Analyzer analyzer should open on the server even if a child is selected just like server properties.
3. Have the subsequent queries select the tab that was previously selected.  So if Grid is selected and a query is executed then the Grid tab is now selected.
4. SQL Prediction puts ( ) for set values in an UPDATE Statement ... ( ) removed
5. If "Text Results" are disabled and a query is executed which does not return any results, then set the focus to the "Messages" Tab.
6. Added Syntax Coloring for all Built-in Functions with dark green
7. Ability to sort table columns.  You may sort grid results by clicking the column, alternating between ascending, descending and no-sort.
8. Added Query Analyzer Clone (Ctrl-Shift-Q) - This will open a new Query Analyzer with a new connection using the same settings as the current Query Analyzer
9. Grid Results - You may now select individual cells, individual rows by row number and columns by column header
10. Added Row #'s to the rows in the grid
11. ADS now sets the .setMaxRow() on a Statement before executing an SQL Statement
12. Stop Button now works on long running queries on the database server.

Installer & Packaging
----------------------
1. OSX - Packager and Launcher - You may now launch the OSX installed application by double clicking on an icon.

Save Results
------------------------------------------------
1. When selecting a file and there is no extension, an extension will be added according to what data format
   is currently selected. ".txt" for delimited text, ".html" for HTML and ".xml" for XML files

Choose Server
------------------
1. Refresh the servers when openning the Dialog.

Miscellaneous
--------------
1. Ability to hide the left browser panel
2. Remember the "last SQL Directory opened" for mounting directories, saving results and saving files

Bugs
-------------
1. Bug: The text results page loses text clarity if scrolled horizontally
2. Bug: Ctrl-Describe has an alignment problem on "smalldatetime"
3. Bug: Syntax Editor: UPDATE "update EMPLOYEE set EMPLOYEEID=1, FOLDERID=2, NAME='d' where " the quoted text is not red
4. Bug: Describe Query when there is no query generates a stack trace
5. Bug: Quoted text with N for NVARCHAR (eg: N'My Text') doesn't make the quoted text red. fixed.

Schema Browser
--------------
1. If you right-click on the schema window it popups up the window but doesn't select the node.
2. Oracle - Display management and other folders even if the user doesn't have access to them.
3. Added Folder for Triggers to Sybase
4. NOTE: Generic-JDBC Connections don't refresh the metadata. It seems most drivers do this because of performance reasons.  I can't change this :(  This is driver specific.


--- End 3.0 ---













2.0.7 : Sybase IQ returns (null) datatype on some queries which causes the ADS Query Window to hang. Fixed
	  RAW datatype in Oracle were not displayed correctly. Fixed

2.0.6 : Passwords larger then 23 characters failed to encrypt.  Fixed.

2.0.5 : Mounting a directory with files that didn't have extensions caused a stack dump.  Fixed.

2.0.4 : Removed AS keyword from Sybase specific code so that the Sybase connections work with Sybase 11.9.  Sybase 11.9 does not support this keyword

2.0.3 : Converted LEFT JOINS to TABLE1, TABLE2 join formats in schema queries for Sybase so that it would work for Sybase 11.9.  Also, fixed minor bug on field-autocompletion for Sybase.

2.0.2 : Changed Font of the Grid Table to Courier New, so that it displays Chinese Characters.

2.0.1 : Fixed: Generic-JDBC - Auto-Completion - Some generic jdbc drivers did not auto-complete on columns, such as ODBC-Access. Now Fixed.

2.0:
--- Start 2.0 ---

Database Support
-----------------
1. Added support for TDS5.5/jConnect5.5 for Sybase
2. Added support for JDBC-OCI driver for Oracle

Query Analyzer
-----------------
1. Changed "Run" text to "Execute" text
2. Mapped F5 key to "Execute".  CTRL-E and F5 both execute the current script
3. Added "Execute Current" (Statment) mapped to CTRL-ENTER hot key.  This will execute the statement the cursor is located on.
4. Added "To Upper" and "To Lower" commands to allow user to quickly convert the highlighted text to upper or lower case.
4. Changed hot-key for "Cancel" to Ctrl-Backspace. (Ctrl-Pause never worked :))
5. Added option to allow user to specify the max number of rows fetched per resultset
6. Added ability to set the Auto-commit to ON or OFF
7. Added ability to 'Commit' and 'Rollback' a transaction from each connection window
8. Added ability to set the Autocompletion to ON or OFF
9. Added ability to set the "Auto on all Schemas" feature, which allows the ability to query for a tables columns across all schemas not just the current one.
10. Ability to refresh the autocompletion cached schema in case the user changes the schema structure
11. Ability to do a Find in the text results of a query.  Set focus on the results panel and then hit Ctrl-F and the find dialog will prompt for the text to search the results
12. Ctrl-D for auto describe now describes all the tables for the current query and shouldn't need the user to highlight the table

Menus
-----------------
1. Added "Describe" and "SQL Prediction" to the query menu
2. Added "New Server Group" and "Delete Server Group" to server menu


Toolbars
-----------------
1. Button tooltips also display the hot-key for that actions ( e.g. Execute (Ctrl-E) )

Options Dialog
-----------------
1. Default Values a. AutoCompletion, Auto on all Schemas, AutoCommit, Max Results
2. Scripts: Ability to specifing filter for scripts (.sql, .proc)

Script Browser
-----------------
1. Scripts displayed are now configured according to the extesions defined in the Option Dialog

General
-----------------------
1. Added filter for Scripts (defined in the options dialog) in the Open Script and Save Script file chooser dialog boxes

Packaging
-----------------------
1. Removed Shell Scripts (.sh) from Windows installation
2. Updated Shell Scripts for Linux, Solaris and OSX

Script Engine
----------------
1. Ability to print out binary data in HEX format in SELECT statements

Schema Browser
----------------
1. Added parameter folder for Oracle stored procedures and functions.
2. Changed query for Oracle sessions to query on  v$session instead of v_$session

Generic JDBC
----------------
1. Added support for AutoCompletion on tables and columns.  The AutoCompletion only queries on the current database and schema.
2. Added the ability to load drivers dynamically by specifying the driver jars at registration

Server Properties
----------------
1. Made database server properties editable.
2. Server Properties is editable even a child node of the server is selected.


Bug/Feature: Optimized the Encryption/Decryption of passwords to speed up the expansion of Server Groups in the schema browser

--- End 2.0 ---






1.5.8 : Fixed: Postgres Schema - Schema precision and scale definition for numeric types where incorrect. Now Fixed.

1.5.7 : Fixed: Generic JDBC connection - Unable to connect to the Mckoi database, because of driver registration implementation. Made registration/connections to generic drivers more flexible. Now Fixed.

1.5.6 : Fixed: Query Analyzer - If the text results in the "Text Result" tab of the Query Analyzer is selected, copied and pasted into Notepad or other text editor the linefeeds are lost. Now Fixed.

1.5.5 : Fixed: Postgres 7.3 - Support for displaying Unicode characters.

1.5.4 : Fixed: Postgres 7.3 - Views, Users, Groups and other folders in
schema browser are not displayed (It seems 7.3 meta data schema has
changed). Now Fixed.

1.5.3 : Fixed: Generic JDBC/Interbase - Generic JDBC connection for
Interbase didn't work. Now fixed.

1.5.2 : Fixed: Postgres 7.3 - Table in schema browser are not displayed. Now
Fixed

1.5.1 : Fixed: SQL Server column auto-completion to query all tables in the
current database and not to filter on schema. This bug only affects users
who are logged into a database as a user who does not own the schema he/she
is working on.

--- Version 1.5 ---
1. Feature: Support for DB2 7.2 and 8.1
2. Feature: Support for Sybase 12.5
3. Feature: Support for Postgres
4. Feature: Support for Generic JDBC
5. Feature: Added support for detecting JRE version to make sure users use
jre 1.4 and above to run Aqua Data Studio
6. Bug fix: A double-click on text in the editor would not select the text. fixed.

--- Version 1.1.3 ---

1. Feature: Changed Tar packaging so that shell scripts and java is untarred
with +x mod set to true
2. Bug fix: Changed all SQL Server Catalog queries to lowercase.  In SQL Server
configurations with case-sensitivity set to true the catalog queries would
fail because the columns in the queries were in caps.
3. Bug fix: When using AutoCompletion and selecting to complete a column with
the ENTER key while typing a TABLE.COLUMN definition, the TABLE.COLUMN definition
would be replaced only with the COLUMN. Fixed.

--- Version 1.1 ---

1. Feature: Added support for asynchronous query execution. You many
now cancel a query at any time or execute multiple queries from different
windows at the same time.
2. Bug fix: SQL Server schema browser showed all columns with
nchar and char types with incorrect size.  If you can't access your database
you will need to re-register the server.
3. Bug fix: Encoding of encrypted password was incorrect, which cause
decrypting of some passwords not to work.  In this case you could not
connect to your server.
4. Bug fix: Moved all /bin files to root directory for easier
understanding of installation and execution of the application
